{-----------------------------------------------------------------------------
 Unit Name: ParserBuilder_Main
 Author:    pat connors
 Purpose: Main form of ParserBuilder
-----------------------------------------------------------------------------}


unit ParserBuilder_Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, ComCtrls, EditStreamCallbackHandler,
  pbSHRichEdit, COCOTreeBuilder, CocoImporter, CompilerObj,
  pbStrLib, TreeEditSync, Placemnt, ImgList, ToolEdit, Mask,
  pbCocoFileSystem, Menus, MRUList, ActnList, StdActns, ActnMan,
  ActnCtrls, ToolWin, JclRegistry, JclMiscel, fileutil,
  CocoGen3, RXSpin, jclSysUtils, JvAssociateExtension, JvGradientCaption,
  ehsbase, ehswhatsthis, ehscontextmap, ehshelprouter, DelphiMethodWizardForm,
  JvRichEditToHtml, JvCombobox, JvFontCombobox, ProductionChecker, jclStrings,
  MXPMenu, ParserUnitImportParserComponent, ClipBrd, BandActn,
  CustomizeDlg, JvDragDrop, StrHlder;

type
  TfrmParserBuilderMain = class(TForm)
    pnlMain: TPanel;
    splitterTreeView: TSplitter;
    pagectrlATGEditing: TPageControl;
    TabSheet2: TTabSheet;
    FormStorage1: TFormStorage;
    TabSheet4: TTabSheet;
    pagectrlOutputViews: TPageControl;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    ilTree: TImageList;
    reParserOutput: TRichEdit;
    reScannerOutput: TRichEdit;
    reProjectOutput: TRichEdit;
    pnlOptions: TPanel;
    lbleditOptions: TLabel;
    edOptions: TEdit;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Close1: TMenuItem;
    RenameReposition1: TMenuItem;
    MakeSnapshotCopy1: TMenuItem;
    N1: TMenuItem;
    MakeMilestone1: TMenuItem;
    AbandonChanges1: TMenuItem;
    N4: TMenuItem;
    Exit1: TMenuItem;
    Compiler1: TMenuItem;
    Build1: TMenuItem;
    Options1: TMenuItem;
    Help1: TMenuItem;
    AboutApp1: TMenuItem;
    View1: TMenuItem;
    ExpandTree1: TMenuItem;
    CollapseTree1: TMenuItem;
    pnlFrames: TPanel;
    lbledCompFrame: TLabel;
    lbledParserFrame: TLabel;
    lbledOutputDirectory: TLabel;
    lbledScannerFrame: TLabel;
    fnCompFrame: TFilenameEdit;
    fnParserFrame: TFilenameEdit;
    fnScannerFrame: TFilenameEdit;
    RecentFiles1: TMenuItem;
    MRUManager1: TMRUManager;
    lbleditErrorFormat: TLabel;
    edErrorFormat: TEdit;
    N2: TMenuItem;
    ChangeHistory1: TMenuItem;
    N12: TMenuItem;
    diredOutputDirectory: TDirectoryEdit;
    SyntaxCheck1: TMenuItem;
    Commands: TActionList;
    actNew: TAction;
    actOpen: TAction;
    actClose: TAction;
    actRename: TAction;
    actSnapshotCopy: TAction;
    actMakeMilestone: TAction;
    actRevertToMilestone: TAction;
    actChangeHistory: TAction;
    actDocumentProperties: TAction;
    actAbandonChanges: TAction;
    actExit: TAction;
    Edit3: TMenuItem;
    Replace1: TMenuItem;
    Find1: TMenuItem;
    N14: TMenuItem;
    Paste1: TMenuItem;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    N15: TMenuItem;
    Undo1: TMenuItem;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    EditSelectAll1: TEditSelectAll;
    EditUndo1: TEditUndo;
    actExpandTree: TAction;
    actCollapseTree: TAction;
    actBuild: TAction;
    actSyntaxCheck: TAction;
    actOptions: TAction;
    actAbout: TAction;
    actPasteSpecial: TAction;
    actFind: TAction;
    actReplaceText: TAction;
    actGoto: TAction;
    ilActions: TImageList;
    ActionManager1: TActionManager;
    coolbarMain: TCoolBar;
    acttbFile: TActionToolBar;
    acttbEdit_View: TActionToolBar;
    acttbHistory: TActionToolBar;
    acttbProject: TActionToolBar;
    TabSheet3: TTabSheet;
    memoReport: TMemo;
    actApplyCocoEdits: TAction;
    actBuildAndRun: TAction;
    actFindMethod: TAction;
    BuildandRun1: TMenuItem;
    N5: TMenuItem;
    ParserSource1: TMenuItem;
    ScannerSource1: TMenuItem;
    CompilerSource1: TMenuItem;
    CodeGenerationReport1: TMenuItem;
    actParserSource: TAction;
    actScannerSource: TAction;
    actCompiler: TAction;
    actGenReport: TAction;
    actCompilerSettings: TAction;
    cbTraceAutomation: TCheckBox;
    cbGenCompiler: TCheckBox;
    cbPrintSets: TCheckBox;
    cbTraceComp: TCheckBox;
    cbForceListing: TCheckBox;
    cbTopDownGraph: TCheckBox;
    cbParserOnly: TCheckBox;
    cbPrintSymTable: TCheckBox;
    cbGrammarTestOnly: TCheckBox;
    cbPrintXRefList: TCheckBox;
    cbWhitespace: TCheckBox;
    StatusBar1: TStatusBar;
    pnlHistory: TPanel;
    lbHistory: TListBox;
    Splitter2: TSplitter;
    Bevel1: TBevel;
    lblHistory: TJvGradientCaption;
    lblFrames: TJvGradientCaption;
    lblOptions: TJvGradientCaption;
    lbledDelphiProject: TLabel;
    btnRestProjectFilename: TBitBtn;
    lblATGEditor: TJvGradientCaption;
    actTestBuild: TAction;
    cbIgnoreCase: TCheckBox;
    pnlFontSize: TPanel;
    seFontSize: TRxSpinEdit;
    HelpRouter1: THelpRouter;
    WhatsThis2: TMenuItem;
    cbGenNames: TCheckBox;
    actViewUses: TAction;
    actViewGlobal: TAction;
    actViewPrivate: TAction;
    actViewProtected: TAction;
    actViewPublic: TAction;
    actViewPublished: TAction;
    actViewCreate: TAction;
    actViewDestroy: TAction;
    actViewArbitraryCode: TAction;
    CodeGeneration1: TMenuItem;
    N6: TMenuItem;
    DelphiSections1: TMenuItem;
    actViewUses1: TMenuItem;
    actViewGlobal1: TMenuItem;
    actViewPrivate1: TMenuItem;
    actViewProtected1: TMenuItem;
    actViewPublic1: TMenuItem;
    actViewPublished1: TMenuItem;
    actViewCreate1: TMenuItem;
    actViewDestroy1: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    ArbitraryCode1: TMenuItem;
    actViewCharacters: TAction;
    actViewIgnore: TAction;
    actViewTokens: TAction;
    actViewPragmas: TAction;
    actViewNames: TAction;
    actViewProductions: TAction;
    actViewOptions: TAction;
    actViewFrames: TAction;
    actViewComments: TAction;
    N11: TMenuItem;
    ATGSections1: TMenuItem;
    Characters1: TMenuItem;
    CommentHandling1: TMenuItem;
    FramesandOutput1: TMenuItem;
    Ignore1: TMenuItem;
    okens1: TMenuItem;
    Options2: TMenuItem;
    Pragmas1: TMenuItem;
    actViewATG: TAction;
    N16: TMenuItem;
    CompleteATG1: TMenuItem;
    actRollBack: TAction;
    actNewDelphiMethod: TAction;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    reverttoMilestone1: TMenuItem;
    ATG2HTMLExporter: TJvRichEditToHtml;
    N3: TMenuItem;
    N7: TMenuItem;
    ExportasHTML1: TMenuItem;
    SaveDialog1: TSaveDialog;
    actExportAsHTML: TAction;
    NewDelphiMethod1: TMenuItem;
    actEditCompFrame: TAction;
    actEditParserFrame: TAction;
    actEditScannerFrame: TAction;
    N17: TMenuItem;
    Frames1: TMenuItem;
    EditParserFrame1: TMenuItem;
    EditScannerFrame1: TMenuItem;
    EditCompilerFrame1: TMenuItem;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    edEXEName: TFilenameEdit;
    FindDialog1: TFindDialog;
    ReplaceDialog1: TReplaceDialog;
    actExploreOutput: TAction;
    SpeedButton5: TSpeedButton;
    HelpContextMap1: THelpContextMap;
    WhatsThis1: TWhatsThis;
    JvFontCombobox1: TJvFontCombobox;
    actHelpContents: TAction;
    Contents1: TMenuItem;
    N13: TMenuItem;
    actRefresh: TAction;
    Panel2: TPanel;
    comboDelphiVersion: TComboBox;
    seATGIndent: TRxSpinEdit;
    MXPMenu1: TMXPMenu;
    actImportDelphi: TAction;
    Importmodifiedparserunit1: TMenuItem;
    actGreySemActions: TAction;
    GreySemanticActions1: TMenuItem;
    actToggleHighlight: TAction;
    N18: TMenuItem;
    oggleSyntaxHighlights1: TMenuItem;
    actBuildFromFile: TAction;
    Generatedirectlyfromfile1: TMenuItem;
    actCompWrapper: TAction;
    CreateComponentWrapper1: TMenuItem;
    shCompTemplate: TStrHolder;
    Panel3: TPanel;
    BitBtn2: TBitBtn;
    actClearHistory: TAction;
    actFindATG: TAction;
    FindSelectedMethod1: TMenuItem;
    FindATGSection1: TMenuItem;
    actViewLanguageSample: TAction;
    actLoadLanguageSample: TAction;
    N19: TMenuItem;
    LOadLanguageSample1: TMenuItem;
    ViewLanguageSample1: TMenuItem;
    pnlLangSamp: TPanel;
    memoLangSamp: TMemo;
    lblUtilMemo: TJvGradientCaption;
    N20: TMenuItem;
    Panel4: TPanel;
    btnHelp: TSpeedButton;
    Productions1: TMenuItem;
    actErrorAlerts: TAction;
    AllowErrorAlertswhensaving1: TMenuItem;
    actStringify: TAction;
    N21: TMenuItem;
    urnselectionintostrings1: TMenuItem;
    PopupMenuATGEditor: TPopupMenu;
    Cut2: TMenuItem;
    Copy2: TMenuItem;
    Paste2: TMenuItem;
    SelectAll1: TMenuItem;
    N22: TMenuItem;
    FindselectedATGsection1: TMenuItem;
    FindSelectedMethod2: TMenuItem;
    Open2: TMenuItem;
    ApplyChanges1: TMenuItem;
    N23: TMenuItem;
    PopupMenuLangSample: TPopupMenu;
    Cut3: TMenuItem;
    Copy3: TMenuItem;
    Paste3: TMenuItem;
    N24: TMenuItem;
    SelectAll2: TMenuItem;
    N25: TMenuItem;
    OpenLanguageSample1: TMenuItem;
    actAddToScraps: TAction;
    actViewScraps: TAction;
    pnlScraps: TPanel;
    JvGradientCaption1: TJvGradientCaption;
    memoScraps: TMemo;
    N26: TMenuItem;
    AddToScraps1: TMenuItem;
    ViewScraps1: TMenuItem;
    N27: TMenuItem;
    AddToScraps2: TMenuItem;
    ViewScraps2: TMenuItem;
    pnlLibTree: TPanel;
    tvATGLibrary: TTreeView;
    actBack: TAction;
    actForward: TAction;
    CustomizeActionBars1: TCustomizeActionBars;
    CustomizeToolbars1: TMenuItem;
    CustomizeDlg1: TCustomizeDlg;
    btnSetProjectDPRName: TBitBtn;
    JvDragDrop1: TJvDragDrop;
    actHighlightChanges: TAction;
    btnHighlightChanges: TSpeedButton;
    HighlightChanges1: TMenuItem;
    N28: TMenuItem;
    N29: TMenuItem;
    ParserBuilderCommands1: TMenuItem;
    KeyboardShortcuts1: TMenuItem;
    actSwitchActiveParser: TAction;
    N30: TMenuItem;
    SwitchActiveParser1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure tvATGLibraryClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure File1Click(Sender: TObject);
    procedure MRUManager1Click(Sender: TObject; const RecentName,
      Caption: string; UserData: Integer);
    procedure lbHistoryClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure actNewExecute(Sender: TObject);
    procedure actOpenExecute(Sender: TObject);
    procedure actRenameExecute(Sender: TObject);
    procedure actCloseExecute(Sender: TObject);
    procedure actSnapshotCopyExecute(Sender: TObject);
    procedure actMakeMilestoneExecute(Sender: TObject);
    procedure actRevertToMilestoneExecute(Sender: TObject);
    procedure actChangeHistoryExecute(Sender: TObject);
    procedure actDocumentPropertiesExecute(Sender: TObject);
    procedure actAbandonChangesExecute(Sender: TObject);
    procedure actExitExecute(Sender: TObject);
    procedure actFindExecute(Sender: TObject);
    procedure actReplaceTextExecute(Sender: TObject);
    procedure actExpandTreeExecute(Sender: TObject);
    procedure actCollapseTreeExecute(Sender: TObject);
    procedure actAboutExecute(Sender: TObject);
    procedure actBuildExecute(Sender: TObject);
    procedure actSyntaxCheckExecute(Sender: TObject);
    procedure actOptionsExecute(Sender: TObject);
    procedure actNewUpdate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure actApplyCocoEditsExecute(Sender: TObject);
    procedure actBuildAndRunExecute(Sender: TObject);
    procedure actFindMethodExecute(Sender: TObject);
    procedure actParserSourceExecute(Sender: TObject);
    procedure actCompilerExecute(Sender: TObject);
    procedure actScannerSourceExecute(Sender: TObject);
    procedure actGenReportExecute(Sender: TObject);
    procedure actCompilerSettingsExecute(Sender: TObject);
    procedure cbTraceAutomationClick(Sender: TObject);
    procedure seFontSizeChange(Sender: TObject);
    procedure btnRestProjectFilenameClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: word;
      Shift: TShiftState);
    procedure tvATGLibraryChange(Sender: TObject; Node: TTreeNode);
    procedure actViewUsesExecute(Sender: TObject);
    procedure actNewDelphiMethodExecute(Sender: TObject);
    procedure actRollBackExecute(Sender: TObject);
    procedure actExportAsHTMLExecute(Sender: TObject);
    procedure actEditCompFrameExecute(Sender: TObject);
    procedure actEditParserFrameExecute(Sender: TObject);
    procedure actEditScannerFrameExecute(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure actExploreOutputExecute(Sender: TObject);
    procedure pagectrlOutputViewsChange(Sender: TObject);
    procedure pagectrlATGEditingChange(Sender: TObject);
    procedure StatusBar1DblClick(Sender: TObject);
    procedure actHelpContentsExecute(Sender: TObject);
    procedure actRefreshExecute(Sender: TObject);
    procedure seATGIndentChange(Sender: TObject);
    procedure actImportDelphiExecute(Sender: TObject);
    procedure actImportDelphiHint(var HintStr: string;
      var CanShow: boolean);
    procedure actGreySemActionsExecute(Sender: TObject);
    procedure actToggleHighlightExecute(Sender: TObject);
    procedure actBuildFromFileExecute(Sender: TObject);
    procedure actCompWrapperExecute(Sender: TObject);
    procedure actClearHistoryExecute(Sender: TObject);
    procedure actFindATGExecute(Sender: TObject);
    function HelpRouter1Help(Command: word; Data: Integer;
      var CallHelp: boolean): boolean;
    procedure actViewLanguageSampleExecute(Sender: TObject);
    procedure memoLangSampChange(Sender: TObject);
    procedure actLoadLanguageSampleExecute(Sender: TObject);
    procedure actStringifyExecute(Sender: TObject);
    procedure actAddToScrapsExecute(Sender: TObject);
    procedure actViewScrapsExecute(Sender: TObject);
    procedure actBackExecute(Sender: TObject);
    procedure actForwardExecute(Sender: TObject);
    procedure CustomizeActionBars1Execute(Sender: TObject);
    procedure btnSetProjectDPRNameClick(Sender: TObject);
    procedure JvDragDrop1Drop(Sender: TObject; Pos: TPoint;
      Value: TStringList);
    procedure actHighlightChangesExecute(Sender: TObject);
    procedure ParserBuilderCommands1Click(Sender: TObject);
    procedure actSwitchActiveParserExecute(Sender: TObject);
    procedure KeyboardShortcuts1Click(Sender: TObject);
  private
    { Private declarations }
    fSuppressHighlight: boolean;
    fHighlightColor: Integer;
    fHistoryShowing: boolean;
    fpbSHRichEdit: TpbSHRichEdit;
    fSHPanel: TPanel;

    fCOCOTreeBuilder: TCOCOTreeBuilder;
    FCocoImporter: TCocoImporter;
    FCompilerList: TList;
    //    FCompiler: TCompiler;
    fTreeEditSync: TTreeEditSync;
    FPermFileName: string;
    fFileSys: TpbCocoFileSystem;
    FActiveCompiler: TCompiler;
    fClosing: boolean;
    // The following two variables allow the ATG Editor contents to be updated
    // while maintaining the position of the cursor and scrolling.
    fPrevEditName: string;
    FScraps: string;
    fBack: string;
    fForward: string;
    procedure PopulateTreeFromCompiler;
    procedure EditSelectedTreeItem;
    //    procedure ResetCompiler;
    procedure TestATGGeneration;
    procedure BuildParser;
    procedure CreateDefaultOutputDir;
    procedure ShowATGEditor;

    procedure DeepRefresh;
    procedure LiteRefresh;
    procedure DoTreeSelectionChange;
    procedure EditFrames;
    procedure UpdateFramesPanel;
    procedure EditOptions;
    procedure OpenFile(const fn: string);
    procedure SetActiveCompiler(const Value: TCompiler);
    function CreateCompiler: TCompiler;
    procedure DeleteCompilerFromList(Cmplr: TCompiler);
    procedure SetFileSystemCompiler(Sender: TObject);
    procedure CloseFileSystemCompiler(Sender: TObject);
    //    procedure ResetActiveCompiler;
    procedure DisplayChangeHistoryView;
    procedure DoHistoryTitleSelected;
    procedure SaveWorkspace;
    procedure RestoreWorkspace;
    procedure ApplyFrames;
    function RunWizard(var S: string): boolean;
    // Actions
    procedure NewFile;
    procedure DoOpenFile;
    procedure CloseFile;
    procedure ApplyAllEdits;

    procedure RenameFile;
    procedure SnapshotCopyFile;
    procedure MakeMilestoneFile;
    procedure RevertToMilestoneFile;
    procedure ChangeHistoryFile;
    procedure DocumentPropertiesFile;
    procedure AbandonChangesFile;
    procedure ExitApp;
    //    procedure PasteSpecial;

    procedure Findtext;
    procedure ReplaceText;

    procedure ExpandTree;
    procedure CollapseTree;

    procedure Build;
    procedure SyntaxCheck;
    procedure AboutApp;
    procedure UpdateGUIActions;
    procedure EditATG(const NewText: string);
    procedure HighlightEditorOnce;
    procedure SetFramesAndTargetDirs;
    procedure BuildAndRun;
    procedure FindMethod;
    function GetLineUnderCursor: string;
    function GetProdUnderCursor: string;
    function CreateDOSProcessRedirected(const CommandLine, InputFile,
      OutputFile, Directory: string): boolean;
    procedure ShowParser;
    procedure ShowScanner;
    procedure ShowCompiler;
    procedure ShowBuildReport;
    procedure ShowCompilerSettings;
    procedure OptionCheckboxClicked(const optIdx: Integer);
    procedure SetOptionsCheckboxes;
    procedure SetupActionHints;
    procedure DisplayHint(Sender: TObject);
    procedure ShowDelphiView(ViewIdx: Integer);
    procedure NewDelphiMethodWizard;
    procedure RollBack;
    procedure UserMessage(const Msg: string);
    procedure ExportAsHTML;
    procedure ExploreOutput;
    procedure ShowHelpContents;
    procedure CorrectFramesAndPaths;
    procedure CheckProductionEdit;
    procedure ImportDelphi;
    procedure BuildFromFile;
    procedure CreateComponentWrapper;
    function IsProdNodeDirty: boolean;
    procedure ClearHistory;
    procedure FindNodeFromSelText;
    procedure ViewLanguageSample;
    procedure LoadLanguageSample;
    procedure Stringify;
    procedure AddToScraps;
    procedure ViewScraps;
    procedure OnATGEditorModified(Sender: TObject;
      var Key: word; Shift: TShiftState);
    procedure SetScraps(const Value: string);
    procedure SwitchActiveParser;
  public
    { Public declarations }
    property ActiveCompiler: TCompiler read FActiveCompiler write SetActiveCompiler;
    property Scraps: string read FScraps write SetScraps;
  end;

var
  frmParserBuilderMain: TfrmParserBuilderMain;

implementation

uses DelphiDeclarations, CocoCharacters, NewATGWizard, AboutDlg, AALCS2,
  ProdCheck2ParserComponent;

{$R *.dfm}

//---------------------------------------------------------------------------
// Coolbar position save and restore routines
// by Patrick de Kleijn
// Pascal Newsletter #33 - 04-MAR-2002

// These routines do not work properly as I have implemented them.
// Will check it out later - pc

//procedure Store(aCoolBar: TCoolBar; aFilename: string);
//var 
//  I, ID: integer;
//  aFile: TStringList;
//begin
//  I := 0; 
//  ID := 0;
//  aFile := TStringList.Create;
//
//  { Parse all available coolbands }
//  while I = I do // Make this an endless loop
//  begin
//    try
//      ID := aCoolBar.Bands.Items[I].ID;
//    except
//        { Raise an EAbort exception to break out of the endless loop
//          when properties of all coolbands are written to file. We know
//          all coolbands are parsed when EListError is raised if we try
//          to collect properties of a coolband that does not exist }
//      on EListError do
//      begin
//        { All done? Save! }
//        aFile.SaveToFile(aFilename);
//        aFile.Free;
//        Abort; // Crack the loop with EAbort
//      end;
//    end;
//
//    { Write it's properties to file - Set }
//    aFile.Add(IntToStr(ID) + 'Index=' +
//      IntToStr(aCoolBar.Bands.Items[I].Index));
//    aFile.Add(IntToStr(ID) + 'Width=' +
//      IntToStr(aCoolBar.Bands.Items[I].Width));
//
//    I := I + 1;
//  end;
//end;
//
//
//procedure Restore(aCoolBar: TCoolBar; aFilename: string);
//var
//  I, ID: integer;
//  aFile: TStringList;
//begin
//  I := 0; 
//  ID := 0;
//  aFile := TStringList.Create;
//  aFile.LoadFromFile(aFileName);
//
//  { Parse all available coolbands }
//  while I = I do
//  begin
//    try
//      ID := aCoolBar.Bands.Items[I].ID;
//    except
//      on EListError do Abort;
//    end;
//
//    { Restore properties from file - Get }
//    aCoolBar.Bands.Items[I].Index :=
//      StrToInt(aFile.Values[IntToStr(ID) + 'Index']);
//    aCoolBar.Bands.Items[I].Width :=
//      StrToInt(aFile.Values[IntToStr(ID) + 'Width']);
//
//    I := I + 1;
//  end;
//
//  //  Result := True;
//end;
//---------------------------------------------------------------------------



procedure TfrmParserBuilderMain.FormCreate(Sender: TObject);
var 
  idx: integer;
begin
  ActionManager1.FileName := ChangeFileExt(Application.ExeName, 'Toolbar.cfg');
  FCocoImporter := TCocoImporter.Create;
  FCompilerList := TList.Create;
  FActiveCompiler := nil;
  fpbSHRichEdit := TpbSHRichEdit.Create(Self);
  fSHPanel := TPanel.Create(Self);
  fshPanel.BevelOuter := bvNone;
  fshPanel.Align := alClient;
  fshPanel.Parent := tabsheet2;
  seFontSize.AsInteger := 11;
  fpbSHRichEdit.Parent := fshPanel;
  lblATGEditor.Parent := fshPanel;
  fpbSHRichEdit.HideSelection := False;
  fpbSHRichEdit.Align := alClient;
  fpbSHRichEdit.PopupMenu := PopupMenuATGEditor;
  //  fpbSHRichEdit.Enabled := false;
  fCOCOTreeBuilder := TCOCOTreeBuilder.Create;
  fCOCOTreeBuilder.TreeView := tvATGLibrary;
  FCocoImporter.Compiler := FActiveCompiler;
  fCOCOTreeBuilder.Compiler := FActiveCompiler;
  fTreeEditSync := TTreeEditSync.Create(Self);
  fTreeEditSync.TreeView := tvATGLibrary;
  fTreeEditSync.Compiler := FActiveCompiler;
  fFileSys := TpbCocoFileSystem.Create(Self);
  fFileSys.Compiler := FActiveCompiler;
  fFileSys.OnBeforeOpen := SetFileSystemCompiler;
  fFileSys.OnAfterClose := CloseFileSystemCompiler;
  CreateDefaultOutputDir;
  RestoreWorkspace;
  SetupActionHints;
  Application.OnHint := DisplayHint;
  HelpRouter1.Helpfile := ChangeFileExt(Application.ExeName, '.chm');
  fPrevEditName := '-1';

  // These buttons share actions with long captions
  SpeedButton2.Caption := '';
  SpeedButton3.Caption := '';
  SpeedButton4.Caption := '';
  SpeedButton5.Caption := '';

  for idx := 0 to ComponentCount - 1 do
  begin
    if (Components[idx] is TLabel) and (TLabel(Components[idx]).FocusControl <> nil) then
    // Set the labels to reflect their focus-control's help info
    begin
      TLabel(Components[idx]).HelpKeyword :=
        'IDH_' + TLabel(Components[idx]).FocusControl.Name;
    end
    else if (Components[idx] is TWinControl) then
      TWinControl(Components[idx]).HelpKeyword := 'IDH_' + Components[idx].Name;
  end;

  for idx := 0 to Commands.ActionCount - 1 do
  begin
    TAction(Commands[idx]).HelpKeyword := 'IDH_' + Commands[idx].Name;
    TAction(Commands[idx]).Hint := ReplaceAll(TAction(Commands[idx]).Caption +
      '  [' +
      ShortCutToText(TAction(Commands[idx]).ShortCut) + ']', '&', '');
  end;
  fpbSHRichEdit.HelpKeyword := 'ATG Editor';
  fpbSHRichEdit.HelpContext := 10001;
  fpbSHRichEdit.OnKeyDown := OnATGEditorModified;
  fSuppressHighlight := True;
  fHighlightColor := 3;
  btnHighlightChanges.Caption := '';
end;



procedure TfrmParserBuilderMain.tvATGLibraryClick(Sender: TObject);
begin
  pnlHistory.Visible := False;
  fHistoryShowing := False;
  pnlLangSamp.Visible := False;
  pagectrlATGEditing.ActivePageIndex := 0;
//  if (tvATGLibrary.Selected <> nil) then
//    tvATGLibraryChange(tvATGLibrary, tvATGLibrary.Selected);
end;

procedure TfrmParserBuilderMain.EditSelectedTreeItem;
begin
  ActiveCompiler := fTreeEditSync.GetSelectedCompiler;
  if (fActiveCompiler <> nil) then
  begin
    fBack := fForward;
    fForward := tvATGLibrary.Selected.Text;
    pnlHistory.Hide;
    fHistoryShowing := False;
    Splitter2.Visible := False;
    memoLangSamp.Lines.Text := FActiveCompiler.LanguageSample;
    pnlLangSamp.Hide;
    pagectrlATGEditing.ActivePageIndex := 0;
    case fTreeEditSync.GetEditorStyleForNode(tvATGLibrary.Selected.Text) of
      0: ShowATGEditor;
      1: EditOptions;
      2: EditFrames;
    end
  end
  else
    DeepRefresh;
end;

procedure TfrmParserBuilderMain.FormDestroy(Sender: TObject);
begin
  //  Store(coolbarMain,ChangeFileExt(Application.ExeName, '.clb'));
  fTreeEditSync.Free;
  fpbSHRichEdit.Free;
  fSHPanel.Free;
  fCOCOTreeBuilder.Free;
  FCocoImporter.Free;
  FreeObjectList(FCompilerList);
  fFileSys.Free;
  memoScraps.Lines.SaveToFile(ChangeFileExt(Application.ExeName, '.scraps'));
end;

procedure TfrmParserBuilderMain.BitBtn2Click(Sender: TObject);
begin
  TestATGGeneration;
end;

procedure TfrmParserBuilderMain.TestATGGeneration;
begin
end;

procedure TfrmParserBuilderMain.BuildParser;
var
  CGen: TCocoGen3;
begin
  CorrectFramesAndPaths;
  CGen := TCocoGen3.Create;
  fpbSHRichEdit.Enabled := False;
  try
    CGen.GrammarName := fFileSys.FileName;
    CGen.FramesDirectory := ExtractFilePath(Application.ExeName) + '\Frames';
    if DirectoryExists(FActiveCompiler.TargetDirectory) then
      diredOutputDirectory.Text := FActiveCompiler.TargetDirectory
    else
      diredOutputDirectory.Text := ExtractFilePath(Application.ExeName) + 'Output';
    cGen.OutputDirectory := FActiveCompiler.TargetDirectory;
    cGen.Options := '-' + edOptions.Text;
    CGen.ErrorFormat := edErrorFormat.Text;
    CGen.Execute;
    memoReport.Lines.BeginUpdate;
    memoReport.Lines.Text := cGen.OutputStream.DataString;
    memoReport.Lines.EndUpdate;
    reParserOutput.Lines.BeginUpdate;
    reParserOutput.Text := cGen.ParserStream.DataString;
    reParserOutput.Lines.EndUpdate;
    reScannerOutput.Lines.BeginUpdate;
    reScannerOutput.Text := cGen.ScannerStream.DataString;
    reScannerOutput.Lines.EndUpdate;
    reProjectOutput.Lines.BeginUpdate;
    reProjectOutput.Text := cGen.CompilerStream.DataString;
    reProjectOutput.Lines.EndUpdate;
    if (cGen.Succeeded) then
      UserMessage('ATG Syntax OK')
    else
      UserMessage('Error: ATG Syntax Bad');
    if Trim(FActiveCompiler.LanguageSample) <> '' then
      SaveString(FActiveCompiler.LanguageSample,
        RemoveBackSlash(FActiveCompiler.TargetDirectory) + '\sample.txt');
  finally
    CGen.Free;
    pagectrlATGEditing.ActivePageIndex := 1;
    pagectrlOutputViews.BringToFront;
    //    if reParserOutput.Text = '' then
    //    begin
    //      pagectrlOutputViews.ActivePageIndex := 3;
    //      memoReport.SetFocus;
    //    end
    //    else
    //      pagectrlOutputViews.ActivePageIndex := 0;
    // reset so the screen updates
    fPrevEditName := '-1';
    seFontSize.Enabled := False;
    fpbSHRichEdit.Enabled := True;
    fpbSHRichEdit.TabStop := False;
  end;
end;

procedure TfrmParserBuilderMain.PopulateTreeFromCompiler;
var
  idx: integer;
  cmplr: TCompiler;
begin
  UserMessage('Building Parser Library Tree');
  tvATGLibrary.Items.BeginUpdate;
  try
    tvATGLibrary.Items.Clear;

    for idx := 0 to FCompilerList.Count - 1 do
    begin
      cmplr := FCompilerList[idx];
      if FileExists(cmplr.FileName) then
      begin
        fCOCOTreeBuilder.Compiler := cmplr;
        fCOCOTreeBuilder.Execute;
        cmplr.IsDirty := False;
      end;
    end;

    UserMessage('Built Parser Library Tree OK');
  finally
    tvATGLibrary.Items.EndUpdate;
  end;
  SetFramesAndTargetDirs;
  memoReport.Lines.Text := fFileSys.ImportLog;
end;

procedure TfrmParserBuilderMain.DeepRefresh;
begin
  Screen.Cursor := crHourGlass;
  try
    PopulateTreeFromCompiler;
    if (FActiveCompiler <> nil) then
    begin
      LiteRefresh;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
  //  UpdateFramesPanel;
  memoReport.Lines.Text := fFileSys.ImportLog;
end;

procedure TfrmParserBuilderMain.LiteRefresh;
begin
  Caption := 'ParserBuilder - ' + fFileSys.FileName;
  edOptions.Text := Trim(fActiveCompiler.BuildOptions);
end;

procedure TfrmParserBuilderMain.DoTreeSelectionChange;
begin
  if (tvATGLibrary.Selected <> nil) and (tvATGLibrary.Selected <> tvATGLibrary.Items[0]) then
  begin
    EditSelectedTreeItem;
    LiteRefresh;
  end;
end;

procedure TfrmParserBuilderMain.EditFrames;
begin
  CorrectFramesAndPaths;
  fpbSHRichEdit.TabStop := False;
  fPrevEditName := '-1';
  //  lblATGEditor.Visible := False;
  lblFrames.LabelCaption := FActiveCompiler.CompilerName + '/Frames and Output Directory';
  pagectrlATGEditing.ActivePageIndex := 0;
  pnlOptions.Visible := False;
  pnlFrames.Visible := True;
  pnlFrames.BringToFront;
  UserMessage('Showing Frame Editor');
  UpdateFramesPanel;
  seFontSize.Enabled := False;
  fTreeEditSync.LSNodeCaption := 'Frames';
  //  fnCompFrame.SetFocus;
end;

procedure TfrmParserBuilderMain.EditOptions;
begin
  pnlFrames.Visible := False;
  UserMessage('Showing Options Editor');
  fTreeEditSync.EditorStyle := 1; // 1 = Options
  FActiveCompiler.ResetAllEditFlags;
  fpbSHRichEdit.TabStop := False;
  lblOptions.LabelCaption := FActiveCompiler.CompilerName + '/Options';
  SetOptionsCheckboxes;
  pnlOptions.Visible := True;
  pnlOptions.BringToFront;
  seFontSize.Enabled := False;
  fTreeEditSync.LSNodeCaption := 'Options';
  fPrevEditName := '-1';
end;

procedure TfrmParserBuilderMain.File1Click(Sender: TObject);
var
  idx: integer;
begin
  UserMessage('Setting up file history menu.');
  MRUManager1.Strings.Clear;
  for idx := fFileSys.FileHistory.Count - 1 downto 0 do
    MRUManager1.Strings.Add(fFileSys.FileHistory[idx]);
end;

procedure TfrmParserBuilderMain.OpenFile(const fn: string);
begin
  UserMessage('Opening file ' + fn);
  fFileSys.FileName := fn;
  fActiveCompiler.FileName := fn;
  fFileSys.LoadFile;
  fFileSys.AddFilenameToHistory;
  CorrectFramesAndPaths;
  fFileSys.Save;
  DeepRefresh;
  memoReport.Lines.Text := fFileSys.ImportLog;
end;

procedure TfrmParserBuilderMain.MRUManager1Click(Sender: TObject; const RecentName,
  Caption: string; UserData: Integer);
begin
  UserMessage('Opening recently used file ' + RecentName);
  SetFileSystemCompiler(nil);
  OpenFile(RecentName);
  fTreeEditSync.SelectCompilerRootNode;
  EditSelectedTreeItem;
  HighlightEditorOnce;
end;

procedure TfrmParserBuilderMain.SetActiveCompiler(const Value: TCompiler);
begin
  FActiveCompiler := Value;
  if (FActiveCompiler <> nil) then
    FActiveCompiler.saMinIndent := seATGIndent.AsInteger;
  FCocoImporter.Compiler := FActiveCompiler;
  fCOCOTreeBuilder.Compiler := FActiveCompiler;
  fTreeEditSync.Compiler := FActiveCompiler;
  fFileSys.Compiler := FActiveCompiler;
end;

function TfrmParserBuilderMain.CreateCompiler: TCompiler;
begin
  UserMessage('Creating New Compiler');
  Result := TCompiler.Create(Self);
  FCompilerList.Insert(0, Result);
  Result.saMinIndent := seATGIndent.AsInteger;
end;

procedure TfrmParserBuilderMain.DeleteCompilerFromList(Cmplr: TCompiler);
var
  idx: integer;
begin
  UserMessage('Deleting Compiler');
  Assert(cmplr <> nil, 'Cannot free dead compiler.');
  idx := FCompilerList.IndexOf(Cmplr);
  if (idx > -1) then
    FCompilerList.Delete(idx);
  cmplr.Free;
end;

procedure TfrmParserBuilderMain.SetFileSystemCompiler(Sender: TObject);
begin
  ActiveCompiler := CreateCompiler;
end;

procedure TfrmParserBuilderMain.CloseFileSystemCompiler(Sender: TObject);
begin
  FActiveCompiler := fFileSys.Compiler;
  DeleteCompilerFromList(FActiveCompiler);
  FActiveCompiler := nil;
  FFileSys.Compiler := nil;

  if (FCompilerList.Count > 0) then
  begin
    ActiveCompiler := FCompilerList[0];
    DeepRefresh;
    fTreeEditSync.SelectCompilerRootNode;
  end
  else
  begin
    fpbSHRichEdit.Clear;
    tvATGLibrary.Items.Clear;
  end;
  UpdateGUIActions;
end;


procedure TfrmParserBuilderMain.DisplayChangeHistoryView;
var 
  SL: TStringList;
  idx: integer;
begin
  fHistoryShowing := True;
  tvATGLibrary.Selected := tvATGLibrary.Items[0];
  UserMessage('Showing File History');
  fPrevEditName := '-1';
  lbHistory.Clear;
  SL := TStringList.Create;
  ffilesys.GetBackupTitles(SL);
  for idx := SL.Count - 1 downto 0 do
    lbHistory.Items.Add(SL[idx]);
  SL.Free;
  lblHistory.LabelCaption := FActiveCompiler.CompilerName + '/History';
  seFontSize.Enabled := True;
  pnlHistory.Visible := True;
  FActiveCompiler.IsEditing := False;
  Splitter2.Left := pnlHistory.Left + pnlHistory.Width;
  Splitter2.Visible := True;
  pagectrlATGEditing.ActivePageIndex := 0;
  fSHPanel.BringToFront;
  fSHPanel.Width := fpbSHRichEdit.Width + 1;
  if (lbHistory.Items.Count > 0) then
  begin
    lbHistory.ItemIndex := 0;
    DoHistoryTitleSelected;
  end;
end;

procedure TfrmParserBuilderMain.lbHistoryClick(Sender: TObject);
begin
  DoHistoryTitleSelected;
end;

procedure TfrmParserBuilderMain.DoHistoryTitleSelected;
var
  S, S1: string;
  ATGDiff: TaaFileLCS;
  newpos, delpos, LT, LS: integer;
begin
  LS := 1;
  LT := 1;
  Screen.Cursor := crHourGlass;
  try
    if (lbHistory.ItemIndex > -1) then
    begin
      S := lbHistory.Items[lbHistory.ItemIndex];
      //    fpbSHRichEdit.Lines.BeginUpdate;
      UserMessage('Showing historical version ' + S);
      S1 := fFileSys.RetrieveBackup(S);
      // New 17-04-02
      // Will use Julian Bucknall's LCS classes to
      // display a DIFF-type view of the current ATG
      // compared to the selected historical ATG.
      // The RichEdit will scroll to the point of trhe first difference.
      // have done a quick dodgy hack to the LCS class, whereby I pass two strings
      // across rather than filenames. The process saves a file of the diffs
      // and this is read back in - will clean this lot up.
      if actHighlightChanges.Checked then
      begin
        ATGDiff := TaaFileLCS.Create(S1, FActiveCompiler.GetATG);
        try
          S1 := ATGDiff.GetChanges;
        finally
          ATGDiff.Free;
        end;
      end;
      LS := fpbSHRichEdit.SelStart;
      LT := fpbSHRichEdit.SelLength;

      fpbSHRichEdit.Text := S1;
      fpbSHRichEdit.PlainTextCopy := S1;
      fPrevEditName := '-2';
      // ... meaning its not ATG Text and no need to fully refresh the ATG Editor,
      // only the highlighting
      // Crappy magic number stuff - will fix - pc
      HighlightEditorOnce;


      if actHighlightChanges.Checked then
      begin
        if (LS = 0) or (fpbSHRichEdit.SelLength = 0) then
        begin
          newpos := fpbSHRichEdit.FindText('+>',
            0,
            Length(fpbSHRichEdit.Text),
            []);

          delpos := fpbSHRichEdit.FindText('-<',
            0,
            Length(fpbSHRichEdit.Text),
            []);

          if delpos = -1 then
            delpos := newpos + 1;

          if newpos < delpos then
            LS := newpos
          else
            LS := delpos;
          S := Copy(fpbSHRichEdit.Text, fpbSHRichEdit.SelStart, 128);
          LT := pos(#13, S);
        end
      end;
    end;
    lbHistory.SetFocus;
    fpbSHRichEdit.SelStart := LS;
    fpbSHRichEdit.SelLength := LT;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TfrmParserBuilderMain.FormShow(Sender: TObject);
begin
  if FileExists(ChangeFileExt(Application.ExeName, '.scraps')) then
    memoScraps.Lines.LoadFromFile(ChangeFileExt(Application.ExeName, '.scraps'));
  fSuppressHighlight := (ParamStr(1) = '-nsh') or (ParamStr(2) = '-nsh');
  actToggleHighlight.Checked := (not fSuppressHighlight) or actToggleHighlight.Checked;
  //  fpbSHRichEdit.Enabled := True;
  pagectrlATGEditing.ActivePageIndex := 0;
  if (tvATGLibrary.Items.Count > 0) then
    if (tvATGLibrary.Items[0].GetFirstChild <> nil) then
    begin
      tvATGLibrary.SetFocus;
      tvATGLibrary.Items[0].GetFirstChild.Selected := True;
      EditSelectedTreeItem;
      seFontSize.OnChange := seFontSizeChange;
      seFontSizeChange(nil);
    end;
  seATGIndent.Enabled := True;
  fpbSHRichEdit.Color := clInfoBk;
  // This will be reinstated when I debug the Coolbar Restore reoutines. - pc
  //  if FileExists(ChangeFileExt(Application.ExeName, '.clb')) then
  //   Restore(coolbarMain,ChangeFileExt(Application.ExeName, '.clb'));
end;

procedure TfrmParserBuilderMain.RestoreWorkspace;
var
  idx: integer;
  fn, cmf: string; // cmf = command-line file
  SL: TStringList;
begin
  // the file loaded from command-line parameters will be first in the tree
  // if other files get loaded when restoring the last workspace.
  UserMessage('Restoring workspace');
  fn := ChangeFileExt(Application.ExeName, '.workspace');
  if (FileExists(FN)) then
  begin
    SL := TStringList.Create;
    SL.LoadFromFile(fn);
    for idx := 0 to SL.Count - 1 do
    begin
      if pos('{PB}', UpperCase(SL[idx])) > 0 then
        SL[idx] := ReplaceFirst(SL[idx], '{PB}', ExtractFilePath(Application.ExeName));
      SL[idx] := ReplaceAll(SL[idx], '\\', '\');
      if (FileExists(SL[idx])) then
      begin
        SetFileSystemCompiler(nil);
        OpenFile(SL[idx]);
      end;
    end;
    SL.Free;
  end;
  cmf := ParamStr(1);
  if FileExists(cmf) then
  begin
    SetFileSystemCompiler(nil);
    OpenFile(cmf);
  end;
end;

procedure TfrmParserBuilderMain.SaveWorkspace;
var
  idx: integer;
  S, fn: string;
begin
  UserMessage('Saving workspace');
  S := '';
  for idx := 0 to FCompilerList.Count - 1 do
    S := S + TCompiler(fCompilerList[idx]).FileName + #13#10;
  S := Trim(S);
  fn := ChangeFileExt(Application.ExeName, '.workspace');
  SaveString(S, fn);
end;

procedure TfrmParserBuilderMain.ApplyFrames;
begin
  if (FActiveCompiler <> nil) then
  begin
    UserMessage('Applying Edits to Frame Settings');
    FActiveCompiler.COMPILERFRAME := fnCompFrame.Text;
    FActiveCompiler.PARSERFRAME := fnParserFrame.Text;
    FActiveCompiler.SCANNERFRAME := fnScannerFrame.Text;
    FActiveCompiler.TargetDirectory := diredOutputDirectory.Text;
  end;
end;

procedure TfrmParserBuilderMain.NewFile;
var
  S: string;
begin
  UserMessage('Running new ATG file wizard');

  if RunWizard(S) then
  begin
    edEXENAME.Text := '';
    SaveString(S, FPermFileName);
    SetFileSystemCompiler(nil);
    OpenFile(FPermFileName);
    fPrevEditName := '';
    edEXEName.Text := '';
    diredOutputDirectory.Text := '';
    ApplyFrames;
    DeepRefresh;
    fTreeEditSync.SelectCompilerRootNode;
  end;
end;

procedure TfrmParserBuilderMain.DoOpenFile;
begin
  fFileSys.Open;
  if FileExists(fFileSys.Compiler.FileName) then
  begin
    edEXEName.Text := '';
    diredOutputDirectory.Text := '';
    PopulateTreeFromCompiler;
    fTreeEditSync.SelectCompilerRootNode;
    EditSelectedTreeItem;
    HighlightEditorOnce;
    tvATGLibrary.SetFocus;
    memoReport.Lines.Text := fFileSys.ImportLog;
  end
  else
    SetFileSystemCompiler(nil);
end;

procedure TfrmParserBuilderMain.CloseFile;
begin
  UserMessage('Closing ATG File');
  fFileSys.Close;
  edEXEName.Text := '';
  diredOutputDirectory.Text := '';
end;

procedure TfrmParserBuilderMain.AbandonChangesFile;
begin
  UserMessage('Abandoning changes made this session');
  FActiveCompiler.ResetAllEditFlags;
  fFileSys.AbandonChanges;
  tvATGLibrary.SetFocus;
  fTreeEditSync.SelectCompilerRootNode;
  EditSelectedTreeItem;
  HighlightEditorOnce;
  memoReport.Lines.Text := fFileSys.ImportLog;
end;

procedure TfrmParserBuilderMain.ChangeHistoryFile;
begin
  DisplayChangeHistoryView;
end;

procedure TfrmParserBuilderMain.DocumentPropertiesFile;
begin
  fFileSys.DocumentProperties;
end;

procedure TfrmParserBuilderMain.ExitApp;
begin
  UserMessage('Closing down ParserBuilder');
  SaveWorkspace;
  Close;
end;

procedure TfrmParserBuilderMain.MakeMilestoneFile;
begin
  UserMessage('Making milestone copy of ATG file');
  fFileSys.MakeMilestone;
end;

procedure TfrmParserBuilderMain.RenameFile;
begin
  UserMessage('Renaming File');
  fFileSys.RenameOrReposition;
  edEXEName.Text := '';
  diredOutputDirectory.Text := '';
  DeepRefresh;
end;

procedure TfrmParserBuilderMain.RevertToMilestoneFile;
begin
  UserMessage('Reverting to milestone');
  fFileSys.RevertToMilestone;
  fTreeEditSync.SelectCompilerRootNode;
  DeepRefresh;
end;

procedure TfrmParserBuilderMain.SnapshotCopyFile;
begin
  UserMessage('Making snapshot copy');
  fFileSys.MakeSnapShotCopy;
end;

procedure TfrmParserBuilderMain.actNewExecute(Sender: TObject);
begin
  UserMessage('Creating new ATG file');
  NewFile;
end;

procedure TfrmParserBuilderMain.actOpenExecute(Sender: TObject);
begin
  DoOpenFile;
end;

procedure TfrmParserBuilderMain.actRenameExecute(Sender: TObject);
begin
  RenameFile;
end;

procedure TfrmParserBuilderMain.actCloseExecute(Sender: TObject);
var 
  idx: integer;
begin
  pnlHistory.Hide;
  if tvATGLibrary.Selected <> nil then
    if tvATGLibrary.Selected.Text = 'Parser Library' then
    begin
      // Close ALL ATG Files
      for idx := FCompilerList.Count - 1 downto 0 do
      begin
        ActiveCompiler := FCompilerList[idx];
        CloseFile;
      end;
      Caption := 'ParserBuilder';
      fpbSHRichEdit.Clear;
      tvATGLibrary.Items.Clear;
    end
    else
    begin
      // Close only ACTIVE ATG file
      CloseFile;
      if (FCompilerList.Count = 0) then
        Caption := 'ParserBuilder';
    end;
end;

procedure TfrmParserBuilderMain.actSnapshotCopyExecute(Sender: TObject);
begin
  SnapshotCopyFile;
end;

procedure TfrmParserBuilderMain.actMakeMilestoneExecute(Sender: TObject);
begin
  MakeMilestoneFile;
end;

procedure TfrmParserBuilderMain.actRevertToMilestoneExecute(Sender: TObject);
begin
  RevertToMilestoneFile;
end;

procedure TfrmParserBuilderMain.actChangeHistoryExecute(Sender: TObject);
begin
  FActiveCompiler.ResetAllEditFlags;
  ChangeHistoryFile;
end;

procedure TfrmParserBuilderMain.actDocumentPropertiesExecute(Sender: TObject);
begin
  DocumentPropertiesFile;
end;

procedure TfrmParserBuilderMain.actAbandonChangesExecute(Sender: TObject);
begin
  AbandonChangesFile;
end;

procedure TfrmParserBuilderMain.actExitExecute(Sender: TObject);
begin
  ExitApp;
end;

{ TODO : Modify this to apply to the memoSampLang as well as the ATG Editor. }
procedure TfrmParserBuilderMain.Findtext;
begin
  FindDialog1.FindText := fpbSHRichEdit.SelText;
  FindDialog1.Execute;
end;


procedure TfrmParserBuilderMain.ReplaceText;
begin
  ReplaceDialog1.FindText := fpbSHRichEdit.SelText;
  ReplaceDialog1.Execute;
end;

procedure TfrmParserBuilderMain.actFindExecute(Sender: TObject);
begin
  Findtext;
end;

procedure TfrmParserBuilderMain.actReplaceTextExecute(Sender: TObject);
begin
  ReplaceText;
end;

procedure TfrmParserBuilderMain.CollapseTree;
begin
  tvATGLibrary.FullCollapse;
  if tvATGLibrary.Items.Count > 0 then
    tvATGLibrary.Items[0].Expand(False);
end;

procedure TfrmParserBuilderMain.ExpandTree;
begin
  tvATGLibrary.FullExpand;
  fTreeEditSync.ReselectNode;
  if (tvATGLibrary.Selected = nil) then
    fTreeEditSync.SelectCompilerRootNode;
end;

procedure TfrmParserBuilderMain.actExpandTreeExecute(Sender: TObject);
begin
  ExpandTree;
end;

procedure TfrmParserBuilderMain.actCollapseTreeExecute(Sender: TObject);
begin
  CollapseTree;
end;

procedure TfrmParserBuilderMain.Build;
begin
  BuildParser;
  if reParserOutput.Text = '' then
  begin
    pagectrlOutputViews.ActivePageIndex := 3;
    memoReport.SetFocus;
  end
  else
    pagectrlOutputViews.ActivePageIndex := 0;
end;

procedure TfrmParserBuilderMain.SyntaxCheck;
var
  CGen: TCocoGen3;
begin
  CGen := TCocoGen3.Create;
  try
    CGen.GrammarName := fFileSys.FileName;
    cGen.Options := '-' + edOptions.Text + 'T';
    CGen.ErrorFormat := edErrorFormat.Text;
    CGen.Execute;
    memoReport.Lines.Text := cGen.OutputStream.DataString;
    reParserOutput.Lines.Text := cGen.ParserStream.DataString;
    reScannerOutput.Lines.Text := cGen.ScannerStream.DataString;
    reProjectOutput.Lines.Text := cGen.CompilerStream.DataString;
    if (CGen.Succeeded) then
      UserMessage('Syntax OK')
    else
      UserMessage('Syntax Error(s)');
  finally
    CGen.Free;
    pagectrlATGEditing.ActivePageIndex := 1;
    pagectrlOutputViews.BringToFront;
    pagectrlOutputViews.ActivePageIndex := 3;
    seFontSize.Enabled := False;
    memoReport.SetFocus;
  end;
end;

procedure TfrmParserBuilderMain.AboutApp;
begin
  with TfrmAbout.Create(nil) do
    ShowModal;
end;

procedure TfrmParserBuilderMain.actAboutExecute(Sender: TObject);
begin
  AboutApp;
end;

procedure TfrmParserBuilderMain.actBuildExecute(Sender: TObject);
begin
  Build;
end;

procedure TfrmParserBuilderMain.actSyntaxCheckExecute(Sender: TObject);
begin
  SyntaxCheck;
end;

procedure TfrmParserBuilderMain.actOptionsExecute(Sender: TObject);
begin
  EditOptions;
end;

procedure TfrmParserBuilderMain.UpdateGUIActions;
var
  ACNotNIL: boolean;
begin
  if not fClosing then
  begin
    ACNotNIL := FActiveCompiler <> nil;
    actNew.Enabled := True;
    actOpen.Enabled := True;
    actClose.Enabled := ACNotNIL;
    actApplyCocoEdits.Enabled := ACNotNIL;
    actBuildAndRun.Enabled := ACNotNIL;
    actRename.Enabled := ACNotNIL;
    actSnapshotCopy.Enabled := ACNotNIL;
    actMakeMilestone.Enabled := ACNotNIL;
    actRevertToMilestone.Enabled := ACNotNIL;
    actChangeHistory.Enabled := ACNotNIL;
    actDocumentProperties.Enabled := ACNotNIL;
    actAbandonChanges.Enabled := ACNotNIL;
    actExit.Enabled := True;
    actExpandTree.Enabled := (tvATGLibrary.Items.Count > 0);
    actCollapseTree.Enabled := actExpandTree.Enabled;
    actBuild.Enabled := ACNotNIL;
    actSyntaxCheck.Enabled := ACNotNIL;
    actOptions.Enabled := ACNotNIL;
    actAbout.Enabled := True;
    actPasteSpecial.Enabled := ACNotNIL;
    actFind.Enabled := ACNotNIL and (fpbSHRichEdit.Focused);
    actReplaceText.Enabled := ACNotNIL and (fpbSHRichEdit.Focused);
    actGoto.Enabled := ACNotNIL;
    actRollBack.Enabled := ACNotNIL and (lbHistory.ItemIndex >-1);
    actClearHistory.Enabled := ACNotNIL and (lbHistory.Count > 0);
    actFindMethod.Enabled := (ACNotNIL) and (fpbSHRichEdit <> nil) and
      (fpbSHRichEdit.SelLength > 1);
    actFindATG.Enabled := (ACNotNIL) and (EditCopy1.Enabled);
    actNewDelphiMethod.Enabled := ACNotNIL;
    actParserSource.Enabled := (reParserOutput.Lines.Count > 0);
    actScannerSource.Enabled := (reScannerOutput.Lines.Count > 0);
    actCompiler.Enabled := (reProjectOutput.Lines.Count > 0);
    actGenReport.Enabled := (memoReport.Lines.Count > 0);
    actExportAsHTML.Enabled := (ACNotNIL) and (fpbSHRichEdit.Lines.Count > 0);
    seFontSize.Enabled := (pagectrlATGEditing.ActivePageIndex = 0);
    actEditCompFrame.Enabled := FileExists(fnCompFrame.FileName);
    actEditParserFrame.Enabled := FileExists(fnParserFrame.FileName);
    actEditScannerFrame.Enabled := FileExists(fnScannerFrame.FileName);
    actExploreOutput.Enabled := diredOutputDirectory.Text <> '';
    actRefresh.Enabled := ACNotNIL;
    actImportDelphi.Enabled :=
      ACNotNIL and FileExists(RemoveBackSlash(FActiveCompiler.TargetDirectory) + '\' +
      ExtractFileName(FActiveCompiler.CompilerName) + 'Parser.pas');
    actGreySemActions.Enabled := (ACNotNIL) and
      (FActiveCompiler.CurrentEditObject in [coCompiler, coProductionNode, coProductions]);
    actCompWrapper.Enabled := (ACNotNIL);
    actViewLanguageSample.Enabled := (ACNotNIL);
    actLoadLanguageSample.Enabled := (ACNotNIL);
    actErrorAlerts.Enabled := True;
    seATGIndent.Enabled := (ACNotNIL) and (FActiveCompiler.CurrentEditObject in
      [coProductionNode, coProductions]);
    actStringify.Enabled := (ACNotNIL) and (fpbSHRichEdit <> nil) and
      (fpbSHRichEdit.SelLength > 1);

    actAddToScraps.Enabled :=
      (ActiveControl is TCustomEdit) and
      (TCustomEdit(ActiveControl).SelLength > 0);

    actViewScraps.Enabled := True;

    actBack.Enabled := fBack <> '';
    actforward.Enabled := fForward <> '';
    CustomizeActionBars1.Enabled := True;
    actHighlightChanges.Enabled := fHistoryShowing;
    actSwitchActiveParser.Enabled := (tvATGLibrary.Items.Count > 0) and
      (tvATGLibrary.Items[0].Count > 1);

    // Not used at the moment -->
    // actCompilerSettings.Enabled := False;
  end;
end;

procedure TfrmParserBuilderMain.actNewUpdate(Sender: TObject);
begin
  UpdateGUIActions;
end;

procedure TfrmParserBuilderMain.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  fClosing := True;
end;

procedure TfrmParserBuilderMain.EditATG(const NewText: string);
var
  SATG: string;
begin
  UserMessage('Applying changes to ATG');
  SATG := FActiveCompiler.GetEditedATG(NewText);
  FCocoImporter.Compiler := FActiveCompiler;
  if not FCocoImporter.ParseText(SATG) then
  begin
    memoReport.Lines.Text := FCocoImporter.Log;
    if (FCocoImporter.Log <> '') then
      UserMessage('Error(s) applying changes to ATG');
  end;
  fFileSys.Save;
end;

procedure TfrmParserBuilderMain.actApplyCocoEditsExecute(Sender: TObject);
begin
  UserMessage('Applying all changes');
  ApplyAllEdits;
end;

procedure TfrmParserBuilderMain.HighlightEditorOnce;
begin
  if fSuppressHighlight or (fpbSHRichEdit.Text = '') then  Exit;
  fpbSHRichEdit.SemActionColor := fHighlightColor;
  fpbSHRichEdit.DefAttributes.Name := JvFontCombobox1.Text;
  if (fPrevEditName = '-1') then
    fpbSHRichEdit.PlainTextCopy := fTreeEditSync.getCocoEditorText
  else
    fpbSHRichEdit.PlainTextCopy := fpbSHRichEdit.Text;
  fpbSHRichEdit.HiglightOn := True;
  fpbSHRichEdit.RefreshHighlight;
  fpbSHRichEdit.HiglightOn := False;
end;

procedure TfrmParserBuilderMain.SetFramesAndTargetDirs;
begin
  fnCompFrame.Text := Trim(fActiveCompiler.COMPILERFRAME);
  fnParserFrame.Text := Trim(fActiveCompiler.ParserFrame);
  fnScannerFrame.Text := Trim(fActiveCompiler.ScannerFrame);
  diredOutputDirectory.Text := Trim(fActiveCompiler.TargetDirectory);
end;

procedure TfrmParserBuilderMain.actBuildAndRunExecute(Sender: TObject);
begin
  BuildAndRun;
end;

procedure TfrmParserBuilderMain.BuildAndRun;
var
  FN, PathStr, D6Path: string;
  S, defDir, runparams: string;
  PathList: TStringList;
  idx: integer;
  DelphiVersion: string;
begin
  if (FActiveCompiler <> nil) then
  begin
    Build;
    if (Trim(reParserOutput.Text) <> '') then
    begin
      //      if FileExists(FActiveCompiler.CurrentDelphiProject) then
      //        edEXENAME.Text := FActiveCompiler.CurrentDelphiProject
      //      else
      //      begin
      //        edExeName.Text := RemoveBackSlash(FActiveCompiler.TargetDirectory) + '\' +
      //          FActiveCompiler.CompilerName + 'TestHarness.dpr';
      //        FActiveCompiler.CurrentDelphiProject := edEXEName.Text;
      //      end;

      DelphiVersion := IntToStr(comboDelphiVersion.ItemIndex + 1);
      // Kill the previously output files
      if (FileExists(ChangeFileExt(FActiveCompiler.CurrentDelphiProject, '.exe'))) then
        DeleteFile(ChangeFileExt(FActiveCompiler.CurrentDelphiProject, '.exe'));
      if (FileExists(ChangeFileExt(FActiveCompiler.CurrentDelphiProject, '.buildreport'))) then
        DeleteFile(ChangeFileExt(FActiveCompiler.CurrentDelphiProject, '.buildreport'));

      try
        PathStr := ExtractFilePath(FActiveCompiler.CurrentDelphiProject) + ';' +
          RegReadString(HKEY_CURRENT_USER,
          'Software\Borland\Delphi\' + DelphiVersion + '.0\Library', 'Search Path');
      except
        on E: Exception do
          raise Exception.Create('Could not read Delphi registry key' +
            CRLF + 'Software\Borland\Delphi\' + DelphiVersion +
            '.0\Library\Search Path' +
            CRLF + 'Exception Message:' + CRLF + E.Message);
      end;

      D6Path := RegReadString(HKEY_CURRENT_USER,
        'Software\Borland\Delphi\' + DelphiVersion + '.0', 'App');
      D6Path := ExtractFilePath(D6Path);
      D6Path := Copy(D6Path, 1, Length(D6Path) - 4);

      PathStr := CaseInsensitiveReplaceAll(PathStr, '$(DELPHI)\', d6Path);
      PathStr := ReplaceAll(PathStr, #13#10, '');

      PathList := TStringList.Create;
      StringToStringList(PathStr, ';', PathList);
      defDir := ExtractFilePath(FActiveCompiler.CurrentDelphiProject);
      for idx := 0 to PathList.Count - 1 do
      begin
        S := PathLIst[idx];
        S := NormalDir(fileutil.ShortToLongPath(S));
        PathList[idx] := ExtractRelativePath(defDir, S);
      end;
      PathStr := StringListToString(PathList, ';', False);
      PathList.Free;
      SaveString('-U' + PathStr, DefDir + 'DCC32.CFG');
      FN := 'dcc32.exe';
      defDir := ExtractFilePath(FActiveCompiler.CurrentDelphiProject);
      runparams := ExtractFileName(FActiveCompiler.CurrentDelphiProject);
      S := FN + ' ' + RunParams;
      SaveString(S, DefDir + 'BuildApp.bat');

      ChDir(DefDir);
      if IOResult <> 0 then
        MessageDlg('Cannot find directory ' + DefDir, mtWarning, [mbOK], 0);
      if CreateDOSProcessRedirected(S, '',
        ChangeFileExt(FActiveCompiler.CurrentDelphiProject, '.buildreport'),
        RemoveBackSlash(DefDir)) then
      begin
        Sleep(1000);

        if FileExists(ChangeFileExt(FActiveCompiler.CurrentDelphiProject, '.buildreport')) then
        begin
          memoReport.Lines.LoadFromFile(ChangeFileExt(FActiveCompiler.CurrentDelphiProject,
            '.buildreport'));
        end
        else
        begin
          memoReport.Lines.Text :=
            'Build Report not created - check the *.bat file created to diagnose errors.';
        end;
        WinExec(PChar(ChangeFileExt(FActiveCompiler.CurrentDelphiProject, '.exe')),
          SW_SHOWDEFAULT);
      end;
    end;
    pagectrlOutputViews.ActivePageIndex := 3;
    memoReport.SetFocus;
  end;
end;

procedure TfrmParserBuilderMain.actFindMethodExecute(Sender: TObject);
begin
  FindMethod;
end;

{-----------------------------------------------------------------------------
  Procedure: FindMethod
  Description
  Locates a method in the Arbitrary Code - the method the cursor is sitting on
  currently is in a Private, Protected, Public View
-----------------------------------------------------------------------------}

procedure TfrmParserBuilderMain.FindMethod;
var
  S: string;
  idx: integer;
begin
  S := GetLineUnderCursor;
  fTreeEditSync.SelectNodeNamed('Arbitrary Code');
  fpbSHRichEdit.SetFocus;
  fpbSHRichEdit.SelStart := 0;
  idx := fpbSHRichEdit.FindText(S, 1, Length(fpbSHRichEdit.Text), []);
  fpbSHRichEdit.SelStart := idx;
  fpbSHRichEdit.SelLength := Length(S);
end;

function TfrmParserBuilderMain.GetLineUnderCursor: string;
begin
  Result := Trim(fpbSHRichEdit.SelText);
  if (Result <> '') then Result := 'Parser.' + Result;
end;


{-----------------------------------------------------------------------------
  Procedure: TfrmParserBuilderMain.CreateDOSProcessRedirected
  Arguments: const CommandLine, InputFile, OutputFile, Directory: string
  Result:    boolean

  When the Delphi Command Line Compiler is activated, this method pipes
  the console output into the ParserBuilder GUI.
  (Cannot remember where I nicked this code from - a JEDI library?)
-----------------------------------------------------------------------------}
function TfrmParserBuilderMain.CreateDOSProcessRedirected(const CommandLine, InputFile,
  OutputFile, Directory: string): boolean;
var
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
  SecAtrrs: TSecurityAttributes;
  hInputFile, hOutputFile: THandle;
  fOutPutFile: string;

  function CreateInheritable(var Sa: TSecurityAttributes): PSecurityAttributes;
  begin
    Sa.nLength := SizeOf(Sa);
    Sa.lpSecurityDescriptor := nil;
    Sa.bInheritHandle := True;
    Result := @Sa;
  end;
begin
  Result := False;
  if (InputFile <> '') then
    hInputFile := CreateFile(PChar(InputFile), GENERIC_READ, FILE_SHARE_READ,
      CreateInheritable(SecAtrrs), OPEN_EXISTING, FILE_ATTRIBUTE_TEMPORARY, 0)
  else
    hInputFile := GetStdHandle(STD_INPUT_HANDLE);
  if hInputFile <> INVALID_HANDLE_VALUE then
  begin
    // if the path is relative, then try to fill in the missing detail
    // as saving it otherwise might throw an error.
    fOutputFile := OutputFile;
    if pos(':', fOutputFile) = 0 then
      if pos('\\', fOutputFile) = 0 then
      begin
        //    S1 := ExtractFilePath(FileName);
        //    While (s1[1] = '.') do
        //      Delete(s1,1,1);
        ChDir(ExtractFilePath(Application.ExeName));
        fOutputFile := ExpandFileName(fOutputFile);
        //      FileName := ReplaceFirst(FileName,S1,'\');
      end;


    hOutputFile := CreateFile(PChar(fOutputFile), GENERIC_READ or GENERIC_WRITE,
      FILE_SHARE_READ, CreateInheritable(SecAtrrs), CREATE_ALWAYS,
      FILE_ATTRIBUTE_TEMPORARY, 0);
    if hOutputFile <> INVALID_HANDLE_VALUE then
    begin
      FillChar(StartupInfo, SizeOf(StartupInfo), #0);
      StartupInfo.cb := SizeOf(StartupInfo);
      StartupInfo.dwFlags := STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
      StartupInfo.wShowWindow := SW_HIDE;
      StartupInfo.hStdOutput := hOutputFile;
      StartupInfo.hStdInput := hInputFile;
      Result := CreateProcess(nil, PChar(CommandLine), nil, nil, True,
        CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS, nil, PChar(Directory), StartupInfo,
        ProcessInfo);
      if Result then
      begin
        WaitForSingleObject(ProcessInfo.hProcess, INFINITE);
        CloseHandle(ProcessInfo.hProcess);
        CloseHandle(ProcessInfo.hThread);
      end;
      CloseHandle(hOutputFile);
    end;
    CloseHandle(hInputFile);
  end;
end;

function TfrmParserBuilderMain.RunWizard(var S: string): boolean;
begin
  with TNewATGWizard.Create(Self) do
    try
      Result := Execute;
      if (Result) then
      begin
        FPermFileName := FileName;
        S := ATG;
      end;
    finally
      Free;
    end;
end;

procedure TfrmParserBuilderMain.ApplyAllEdits;
var
  S: string;
begin
  // no saving if viewing history as it uses that same richedit as the general ATG
  if not fHistoryShowing then
  begin
    CheckProductionEdit;
    Assert(FActiveCompiler <> nil, 'pbBUG: Trying to work with NIL compiler.');
    FActiveCompiler.BuildOptions := edOptions.Text;
    FActiveCompiler.saMinIndent := seATGIndent.AsInteger;
    FActiveCompiler.CurrentDelphiProject := edEXENAME.Text;
    FActiveCompiler.LanguageSample := memoLangSamp.Lines.Text;
    ApplyFrames;
    S := fpbSHRichEdit.Text;
    EditATG(S);
    FActiveCompiler.IsDirty := FActiveCompiler.IsDirty or IsProdNodeDirty;
    fPrevEditName := '-1';
    if (FActiveCompiler.IsDirty) then
      DeepRefresh;
    FActiveCompiler.ResetAllEditFlags;
    fFileSys.DoBackup;
    fTreeEditSync.ReselectNode;
    if (tvATGLibrary.Selected = nil) then
      fTreeEditSync.SelectCompilerRootNode;
    fPrevEditName := lblATGEditor.LabelCaption;
    if fpbSHRichEdit.focused then
      fTreeEditSync.EditCurrentNode;
  end;
end;


procedure TfrmParserBuilderMain.actParserSourceExecute(Sender: TObject);
begin
  ShowParser;
end;

procedure TfrmParserBuilderMain.ShowBuildReport;
begin
  pagectrlATGEditing.ActivePageIndex := 1;
  pagectrlOutputViews.BringToFront;
  pagectrlOutputViews.ActivePageIndex := 3;
  seFontSize.Enabled := False;
  memoReport.SetFocus;
end;

procedure TfrmParserBuilderMain.ShowCompiler;
begin
  pagectrlATGEditing.ActivePageIndex := 1;
  pagectrlOutputViews.BringToFront;

  pagectrlOutputViews.ActivePageIndex := 2;
  seFontSize.Enabled := False;
  reProjectOutput.SetFocus;
end;

procedure TfrmParserBuilderMain.ShowParser;
begin
  pagectrlATGEditing.ActivePageIndex := 1;
  pagectrlOutputViews.BringToFront;

  pagectrlOutputViews.ActivePageIndex := 0;
  seFontSize.Enabled := False;
  reParserOutput.SetFocus;
end;

procedure TfrmParserBuilderMain.ShowScanner;
begin
  pagectrlATGEditing.ActivePageIndex := 1;
  pagectrlOutputViews.BringToFront;

  pagectrlOutputViews.ActivePageIndex := 1;
  seFontSize.Enabled := False;
  reScannerOutput.SetFocus;
end;

procedure TfrmParserBuilderMain.actCompilerExecute(Sender: TObject);
begin
  ShowCompiler;
end;

procedure TfrmParserBuilderMain.actScannerSourceExecute(Sender: TObject);
begin
  ShowScanner;
end;

procedure TfrmParserBuilderMain.actGenReportExecute(Sender: TObject);
begin
  ShowBuildReport;
end;

procedure TfrmParserBuilderMain.actCompilerSettingsExecute(Sender: TObject);
begin
  ShowCompilerSettings;
end;

procedure TfrmParserBuilderMain.ShowCompilerSettings;
begin
  ShowMessage('Yet to be implemented');
end;

procedure TfrmParserBuilderMain.cbTraceAutomationClick(Sender: TObject);
begin
  OptionCheckboxClicked((Sender as TCheckBox).Tag);
end;

procedure TfrmParserBuilderMain.OptionCheckboxClicked(const optIdx: Integer);
  procedure AdjustOptions(const ch: char);
  begin
    if (pos(UpperCase(ch), Uppercase(edOptions.Text)) = 0) then
      edOptions.Text := edOptions.Text + ch
    else
      edOptions.Text := CaseInsensitiveReplaceAll(edOptions.Text, ch, '');
  end;
begin
  case optIdx of
    1: AdjustOptions('A');
    2: AdjustOptions('C');
    3: AdjustOptions('F');
    4: AdjustOptions('I');
    5: AdjustOptions('L');
    6: AdjustOptions('N');
    7: AdjustOptions('P');
    8: AdjustOptions('S');
    9: AdjustOptions('T');
    10: AdjustOptions('X');
    11: AdjustOptions('G');
    12: AdjustOptions('W');
    13: FActiveCompiler.IgnoreSection.IgnoreCase := cbIgnoreCase.Checked;
    else
      raise Exception.Create('Unknown Option Index : ' + IntToStr(optIdx));
  end; // Case
end;

procedure TfrmParserBuilderMain.SetOptionsCheckboxes;
begin
  if (fActiveCompiler <> nil) then
  begin
    edOptions.Text := Trim(fActiveCompiler.BuildOptions);
    cbTraceAutomation.Checked := Pos('A', edOptions.Text) > 0;
    cbGenCompiler.Checked := Pos('C', edOptions.Text) > 0;
    cbPrintSets.Checked := Pos('F', edOptions.Text) > 0;
    cbTraceComp.Checked := Pos('I', edOptions.Text) > 0;
    cbForceListing.Checked := Pos('L', edOptions.Text) > 0;
    cbGenNames.Checked := Pos('N', edOptions.Text) > 0;
    cbParserOnly.Checked := Pos('P', edOptions.Text) > 0;
    cbPrintSymTable.Checked := Pos('S', edOptions.Text) > 0;
    cbGrammarTestOnly.Checked := Pos('T', edOptions.Text) > 0;
    cbPrintXRefList.Checked := Pos('X', edOptions.Text) > 0;
    cbTopDownGraph.Checked := Pos('G', edOptions.Text) > 0;

    cbWhitespace.Checked := Pos('W', edOptions.Text) > 0;
    cbIgnoreCase.Checked := FActiveCompiler.IgnoreSection.IgnoreCase;
  end;
end;

procedure TfrmParserBuilderMain.CreateDefaultOutputDir;
var
  S: string;
begin
  S := ExtractFilePath(Application.ExeName) + '\Output\';
  if not DirExists(S) then
    CreateDir(S);
end;

procedure TfrmParserBuilderMain.SetupActionHints;
var
  idx: integer;
begin
  for idx := 0 to ComponentCount - 1 do
    if Components[idx] is TAction then
      TAction(Components[idx]).Hint := TAction(Components[idx]).Caption;
end;

procedure TfrmParserBuilderMain.ShowATGEditor;
var
  TN: TTreeNode;
  S: string;
  LS, LT: integer;
begin
  // 1. Get the name of the selected node
  //      so the user gets a strong sense of what they are editing.
  TN := tvATGLibrary.Selected;
  UserMessage('Editing ATG: ' + TN.Text + ' Section');
  while (TN <> nil) and (TN.Level > 1) do
  begin
    if (S <> '') then S := '/' + S;
    S := TN.Text + S;
    TN := TN.Parent;
  end;
  S := FActiveCompiler.CompilerName + '/' + S;
  lblATGEditor.LabelCaption := 'ATG Editor: ' + S;
  //  lblATGEditor.Visible := True;
  pagectrlATGEditing.ActivePageIndex := 0;
  // Calling "getCocoEditorText" for the side effects
  // - will only use the result if we update the text .. see below
  FActiveCompiler.saMinIndent := seATGIndent.AsInteger;
  S := fTreeEditSync.getCocoEditorText;
  // We only want to update the text if a new
  // section has been selected - otherwise we lose the
  // cursor position in the ATG Editor and its bloody annoying!
  LS := fpbSHRichEdit.SelStart;
  LT := fpbSHRichEdit.SelLength;

  if fPrevEditName <> lblATGEditor.LabelCaption then
  begin
    fpbSHRichEdit.Lines.BeginUpdate;
    fpbSHRichEdit.Text := S;
    fpbSHRichEdit.PlainTextCopy := S;
    fpbSHRichEdit.Lines.EndUpdate;
    fpbSHRichEdit.DefAttributes.Style := [];
    fPrevEditName := lblATGEditor.LabelCaption;
    HighlightEditorOnce;
    if LS < Length(fpbSHRichEdit.Text) then
    begin
      fpbSHRichEdit.SelStart := LS;
      fpbSHRichEdit.SelLength := LT;
    end;
  end;
  fSHPanel.BringToFront;
  pnlOptions.Visible := False;
  pnlFrames.Visible := False;
  fpbSHRichEdit.TabStop := True;
  seFontSize.Enabled := True;
end;

procedure TfrmParserBuilderMain.seFontSizeChange(Sender: TObject);
begin
  try
    if (seFontSize.AsInteger > 7) then
    begin
      fpbSHRichEdit.DefAttributes.Size := seFontSize.AsInteger;
      memoLangSamp.Font.Size := seFontSize.AsInteger;
      if (JvFontCombobox1.Text <> '') then
        memoLangSamp.Font.Name := JvFontCombobox1.Text;
      HighlightEditorOnce;
    end;
  except
  end;
end;

procedure TfrmParserBuilderMain.DisplayHint(Sender: TObject);
begin
  StatusBar1.Panels[0].Text := Application.Hint;
end;

procedure TfrmParserBuilderMain.btnRestProjectFilenameClick(Sender: TObject);
begin
  fActiveCompiler.CurrentDelphiProject := '';
  fActiveCompiler.TargetDirectory := '';
  EditFrames;
end;


procedure TfrmParserBuilderMain.FormKeyDown(Sender: TObject; var Key: word;
  Shift: TShiftState);
begin
  if (Key = VK_F2) then
  begin
    if pagectrlATGEditing.ActivePageIndex = 1 then
    begin
      pagectrlATGEditing.ActivePageIndex := 0;
      Exit;
    end;
    pnlLangSamp.Hide;
    if fHistoryShowing then
    begin
      pnlHistory.Hide;
      fHistoryShowing := False;
      fPrevEditName := '-1';
      tvATGLibrary.SetFocus;
      fTreeEditSync.SelectCompilerRootNode;
      fTreeEditSync.EditCurrentNode;
      fpbSHRichEdit.SetFocus;
    end
    else if fpbSHRichEdit.Focused then
    begin
      tvATGLibrary.SetFocus;
      fTreeEditSync.EditCurrentNode;
    end
    else if tvATGLibrary.Focused then
    begin
      if (pnlOptions.Showing) then edOptions.SetFocus
      else if (pnlFrames.Showing) then fnCompFrame.SetFocus
      else
        fpbSHRichEdit.SetFocus;
    end
    else
    begin
      tvATGLibrary.SetFocus;
      fTreeEditSync.EditCurrentNode;
    end;
    //      else
    //    if  (not pnlOptions.Showing) and (not pnlFrames.Showing)  then
    //    Begin
    //    pagectrlATGEditing.ActivePageIndex := 0;
    //    fSHPanel.BringToFront;
    //    fpbSHRichEdit.SetFocus;
    //    End
    //    else
    //       if  (pnlOptions.Showing) or (pnlFrames.Showing)  then
    //         tvATGLibrary.SetFocus;
  end;
end;

procedure TfrmParserBuilderMain.tvATGLibraryChange(Sender: TObject;
  Node: TTreeNode);
begin
  DoTreeSelectionChange;
end;

procedure TfrmParserBuilderMain.actViewUsesExecute(Sender: TObject);
begin
  ShowDelphiView((Sender as TAction).tag);
end;

procedure TfrmParserBuilderMain.ShowDelphiView(ViewIdx: Integer);
begin
  pagectrlATGEditing.ActivePageIndex := 0;
  case ViewIdx of
    1: fTreeEditSync.SelectNodeNamed('Uses');
    2: fTreeEditSync.SelectNodeNamed('Global');
    3: fTreeEditSync.SelectNodeNamed('Private');
    4: fTreeEditSync.SelectNodeNamed('Protected');
    5: fTreeEditSync.SelectNodeNamed('Public');
    6: fTreeEditSync.SelectNodeNamed('Published');
    7: fTreeEditSync.SelectNodeNamed('Create');
    8: fTreeEditSync.SelectNodeNamed('Destroy');
    9: fTreeEditSync.SelectNodeNamed('Arbitrary Code');
    10: fTreeEditSync.SelectNodeNamed('Characters');
    11: fTreeEditSync.SelectNodeNamed('Ignore');
    12: fTreeEditSync.SelectNodeNamed('Tokens');
    13: fTreeEditSync.SelectNodeNamed('Pragmas');
    14: fTreeEditSync.SelectNodeNamed('Names');
    15: fTreeEditSync.SelectNodeNamed('Productions');
    16: 
    begin
      fTreeEditSync.SelectNodeNamed('Options');
      EditSelectedTreeItem;
    end;
    17: fTreeEditSync.SelectNodeNamed('Frames');
    18: fTreeEditSync.SelectNodeNamed('Comments');
    19: fTreeEditSync.SelectCompilerRootNode;
  end; //Case
  if (ViewIdx in [1..15, 19]) then   fpbSHRichEdit.SetFocus;
end;

procedure TfrmParserBuilderMain.actNewDelphiMethodExecute(Sender: TObject);
begin
  fPrevEditName := '-1';
  NewDelphiMethodWizard;
end;

procedure TfrmParserBuilderMain.NewDelphiMethodWizard;
var 
  ProtoStr, Section: string;
begin
  // Show a dialog that lets the user enter a prototype
  // and nominate which Delphi Section it belongs to
  if ExecNewDelphiMethodWizard(ProtoStr, Section) then
  begin
    if (Section = 'Private') then
      FActiveCompiler.DelphiSection.PrivateDecs :=
        FActiveCompiler.DelphiSection.PrivateDecs + #13#10 + ProtoStr
    else if (Section = 'Protected') then
      FActiveCompiler.DelphiSection.ProtectedDecs :=
        FActiveCompiler.DelphiSection.ProtectedDecs + #13#10 + ProtoStr
    else if (Section = 'Public') then
      FActiveCompiler.DelphiSection.PublicDecs :=
        FActiveCompiler.DelphiSection.PublicDecs + #13#10 + ProtoStr;
    ProtoStr := ReplaceFirst(ProtoStr, ' ', ' T-->GrammarParser.');
    FActiveCompiler.DelphiSection.ArbitraryCodeSection :=
      FActiveCompiler.DelphiSection.ArbitraryCodeSection + #13#10 + ProtoStr +
      #13#10 + 'Begin' + #13#10#13#10 + 'End;' + #13#10;
    fTreeEditSync.SelectNodeNamed('Arbitrary Code');
  end;
end;

procedure TfrmParserBuilderMain.RollBack;
var 
  S: string;
begin
  // Rollback to the most recent backup in the history file
  S := lbHistory.Items[lbHistory.ItemIndex];
  fFileSys.RollBack(S);
  fTreeEditSync.SelectCompilerRootNode;
end;

procedure TfrmParserBuilderMain.actRollBackExecute(Sender: TObject);
begin
  RollBack;
  pnlHistory.Hide;
  ApplyAllEdits;
end;

procedure TfrmParserBuilderMain.UserMessage(const Msg: string);
begin
  StatusBar1.Panels[1].Text := Msg;
end;

procedure TfrmParserBuilderMain.ExportAsHTML;
begin
  // Want to select a filename then
  // run the export via the jedi component
  SaveDialog1.FileName := FActiveCompiler.CompilerName + '.htm';
  if SaveDialog1.Execute then
    ATG2HTMLExporter.ConvertToHtml(fpbSHRichEdit, SaveDialog1.FileName);
end;

procedure TfrmParserBuilderMain.actExportAsHTMLExecute(Sender: TObject);
begin
  ExportAsHTML;
end;

procedure TfrmParserBuilderMain.actEditCompFrameExecute(Sender: TObject);
begin
  WinExec(PChar('notepad.exe ' + fnCompFrame.FileName), SW_SHOWDEFAULT);
end;

procedure TfrmParserBuilderMain.actEditParserFrameExecute(Sender: TObject);
begin
  WinExec(PChar('notepad.exe ' + fnParserFrame.FileName), SW_SHOWDEFAULT);
end;

procedure TfrmParserBuilderMain.actEditScannerFrameExecute(Sender: TObject);
begin
  WinExec(PChar('notepad.exe ' + fnScannerFrame.FileName), SW_SHOWDEFAULT);
end;

procedure TfrmParserBuilderMain.FindDialog1Find(Sender: TObject);
var
  st: TSearchTypes;
  newpos: integer;
  cd: TFindDialog;
begin
  cd := (Sender as TFindDialog);

  if frMatchCase in cd.Options then
    st := st + [stMatchCase];

  if frWholeWord in cd.Options then
    st := st + [stWholeWord];

  if fpbSHRichEdit.SelLength > 0 then
    fpbSHRichEdit.SelStart := fpbSHRichEdit.SelStart + 1;

  newpos := fpbSHRichEdit.FindText(cd.FindText,
    fpbSHRichEdit.SelStart,
    Length(fpbSHRichEdit.Text),
    st);

  if newpos <> -1 then
  begin
    fpbSHRichEdit.SelStart := newpos;
    fpbSHRichEdit.SelLength := Length(cd.FindText);
    fpbSHRichEdit.Repaint;
  end
  else
  begin
    MessageDlg('End of document reached', mtInformation, [mbOK], 0);
    fpbSHRichEdit.SelStart := 0;
  end;
end;

procedure TfrmParserBuilderMain.ReplaceDialog1Replace(Sender: TObject);
begin
  if fpbSHRichEdit.SelLength = 0 then
    FindDialog1Find(Sender)
  else
  begin
    fpbSHRichEdit.SelText := ReplaceDialog1.ReplaceText;
    FindDialog1Find(Sender);
  end;

  if frReplaceAll in ReplaceDialog1.Options then
    while (fpbSHRichEdit.SelLength <> 0) do
      ReplaceDialog1Replace(Sender);
end;

procedure TfrmParserBuilderMain.actExploreOutputExecute(Sender: TObject);
begin
  ExploreOutput;
end;

procedure TfrmParserBuilderMain.ExploreOutput;
begin
  WinExec(PChar('explorer.exe "' + diredOutputDirectory.Text + '"'), SW_SHOWDEFAULT);
end;

procedure TfrmParserBuilderMain.pagectrlOutputViewsChange(Sender: TObject);
begin
  TRichEdit(pagectrlOutputViews.ActivePage.Controls[0]).SetFocus;
end;

procedure TfrmParserBuilderMain.pagectrlATGEditingChange(Sender: TObject);
begin
  if (pagectrlATGEditing.ActivePageIndex = 1) then
  begin
    memoReport.TabStop := True;
    reParserOutput.TabStop := True;
    reScannerOutput.TabStop := True;
    reProjectOutput.TabStop := True;
    fpbSHRichEdit.TabStop := False;
    pnlOptions.Visible := False;
    pnlFrames.Visible := False;
  end
  else
  begin
    memoReport.TabStop := False;
    reParserOutput.TabStop := False;
    reScannerOutput.TabStop := False;
    reProjectOutput.TabStop := False;
    fpbSHRichEdit.TabStop := True;
  end;
end;

{-----------------------------------------------------------------------------
  Procedure: TfrmParserBuilderMain.StatusBar1DblClick

  This is only for development - spitting out lists to be used
  in the help file project.
-----------------------------------------------------------------------------}
procedure TfrmParserBuilderMain.StatusBar1DblClick(Sender: TObject);
  //var
  //  idx: integer;
  //  S: string;
begin
  //  S := '';
  //  for idx := 0 to Commands.ActionCount - 1 do
  //  begin
  //    S := S + TACTION(Commands[idx]).Hint       + #13#10;
  //  end;
  //  SaveString(S, 'KeyShortcuts.txt');

  //  S := '';
  //  for idx := 0 to ComponentCount - 1 do
  //  begin
  //    if (Components[idx] is TControl) then
  //      if not (Components[idx] is TTabSheet) then
  //        S := S + '#define IDH_' + TControl(Components[idx]).Name + ' ' +
  //          IntToStr(TControl(Components[idx]).HelpContext) + #13#10;
  //  end;
  //  SaveString(S, 'pbGUIHelpIDs.h');
  //
  //  S := '';
  //  for idx := 0 to ComponentCount - 1 do
  //  begin
  //    if (Components[idx] is TControl) then
  //      if not (Components[idx] is TTabSheet) then
  //        S := S + '.topic ' + IntToStr(TControl(Components[idx]).HelpContext) +
  //          #13#10 + 'IDH_' + TControl(Components[idx]).Name + #13#10 +
  //          'Help yet to be written' + #13#10#13#10;
  //  end;
  //  SaveString(S, 'CSTopics.txt');
  //
  //  S := '';
  //  for idx := 0 to ComponentCount - 1 do
  //  begin
  //    if (Components[idx] is TControl) then
  //      if not (Components[idx] is TTabSheet) then
  //        S := S + 'IDH_' + TControl(Components[idx]).Name + '=' +
  //          'IDH_' + TControl(Components[idx]).Name + '.htm' + #13#10;
  //  end;
  //
  //  SaveString(S, 'pbGUI.alias');
  //
  //  S := '';
  //  for idx := 0 to Commands.ActionCount - 1 do
  //  begin
  //    S := S + 'IDH_' + TACTION(Commands[idx]).Name + '=' +
  //      'IDH_' + Commands.Actions[idx].Name + '.htm' + #13#10;
  //  end;
  //  SaveString(S, 'pbActions.alias');
  //  S := '';
  //
  //  for idx := 0 to Commands.ActionCount - 1 do
  //  begin
  //    S := S + '#define IDH_' + Commands.Actions[idx].Name + '=' +
  //      IntToStr(TACTION(Commands[idx]).HelpContext) + ';' + #13#10;
  //  end;
  //  SaveString(S, 'pbActions.h');
end;

procedure TfrmParserBuilderMain.actHelpContentsExecute(Sender: TObject);
begin
  ShowHelpContents;
end;

procedure TfrmParserBuilderMain.ShowHelpContents;
begin
  Application.HelpCommand(HELP_CONTENTS, 0);
end;

procedure TfrmParserBuilderMain.actRefreshExecute(Sender: TObject);
var 
  AC: TWinControl;
begin
  AC := ActiveControl;
  pnlHistory.Hide;
  fHistoryShowing := False;
  fPrevEditName := '-1';
  tvATGLibrary.SetFocus;
  fTreeEditSync.ReselectNode;
  fTreeEditSync.EditCurrentNode;
  if (AC = fpbSHRichEdit) then
    HighlightEditorOnce;
  if (AC <> nil) then
    AC.SetFocus;
end;

procedure TfrmParserBuilderMain.CorrectFramesAndPaths;
begin
  fActiveCompiler.COMPILERFRAME := Trim(fActiveCompiler.COMPILERFRAME);
  fActiveCompiler.ParserFrame := Trim(fActiveCompiler.ParserFrame);
  fActiveCompiler.ScannerFrame := Trim(fActiveCompiler.ScannerFrame);
  fActiveCompiler.TargetDirectory := Trim(fActiveCompiler.TargetDirectory);
  if not FileExists(fActiveCompiler.COMPILERFRAME) then
    fActiveCompiler.COMPILERFRAME := ExtractFilePath(Application.ExeName) +
      'Frames\pbCompiler.frm';
  if not FileExists(fActiveCompiler.ParserFrame) then
    fActiveCompiler.ParserFrame := ExtractFilePath(Application.ExeName) +
      'Frames\pbParser.frm';
  if not FileExists(fActiveCompiler.ScannerFrame) then
    fActiveCompiler.ScannerFrame := ExtractFilePath(Application.ExeName) +
      'Frames\pbScanner.frm';
  if not DirectoryExists(fActiveCompiler.TargetDirectory) then
    fActiveCompiler.TargetDirectory :=
      KillFinalDelim(ExtractFilePath(FActiveCompiler.FileName),
      '\');

  if not DirExists(FActiveCompiler.TargetDirectory) then
  begin
    FActiveCompiler.TargetDirectory := ExtractFilePath(Application.ExeName) + 'Output';
  end;

  if not FileExists(FActiveCompiler.CurrentDelphiProject) then
  begin
    FActiveCompiler.CurrentDelphiProject :=
      RemoveBackSlash(FActiveCompiler.TargetDirectory) + '\' +
      FActiveCompiler.CompilerName + 'TestHarness.dpr';
  end;
end;

procedure TfrmParserBuilderMain.CheckProductionEdit;
var
  Report: string;
begin
  if actErrorAlerts.Checked then
    if Pos('Productions', lblATGEditor.LabelCaption) > 0 then
    begin
      if not IsProductionOK(fpbSHRichEdit.Text, Report) then
      begin
        UserMessage('Error in Production');
        raise Exception.Create(Report + #13#10 +
          'You will need to correct the Production(s).');
      end;
      //  else
      //      // Try the more sophisticated production checker
      //      if not ProdCheck2ParserComponent.ExecuteProdCheck2Parser(fpbSHRichEdit.Text,Report) then
      //       begin
      //       UserMessage('Error in Production');
      //       Raise Exception.Create(Report+#13#10+'You will need to correct the Production(s).');
      //     End;
      UserMessage('Production edits OK.');
    end;
end;

procedure TfrmParserBuilderMain.seATGIndentChange(Sender: TObject);
begin
  try
    if (seATGIndent.Enabled) then
      if (StrIsNumber(seATGIndent.Text)) then
      begin
        ActiveCompiler := fTreeEditSync.GetSelectedCompiler;
        fPrevEditName := '-1';
        if (fActiveCompiler <> nil) then
        begin
          pnlHistory.Hide;
          Splitter2.Visible := False;
          pagectrlATGEditing.ActivePageIndex := 0;
          case fTreeEditSync.GetEditorStyleForNode(tvATGLibrary.Selected.Text) of
            0: ShowATGEditor;
            1: EditOptions;
            2: EditFrames;
          end
        end;
      end;
  except
  end;
end;

procedure TfrmParserBuilderMain.actImportDelphiExecute(Sender: TObject);
begin
  ImportDelphi;
end;

procedure TfrmParserBuilderMain.ImportDelphi;
begin
  FActiveCompiler.ResetAllEditFlags;
  fFileSys.DoBackup;
  if ExecuteParserUnitImportParser(FActiveCompiler) then
    actRefresh.Execute
  else
    ShowMessage('There was a problem importing the source code - action cancelled.');
end;

procedure TfrmParserBuilderMain.actImportDelphiHint(var HintStr: string;
  var CanShow: boolean);
begin
  HintStr := 'Import source code from ' + RemoveBackSlash(FActiveCompiler.TargetDirectory)
    + '\' +
    ExtractFileName(FActiveCompiler.CompilerName) + 'Parser.pas';
  CanShow := True;
end;

procedure TfrmParserBuilderMain.actGreySemActionsExecute(Sender: TObject);
begin
  if actGreySemActions.Checked then
    fHighlightColor := 4
  else
    fHighlightColor := 3;
  HighlightEditorOnce;
end;

procedure TfrmParserBuilderMain.actToggleHighlightExecute(Sender: TObject);
begin
  fSuppressHighlight := not actToggleHighlight.Checked;
  fPrevEditName := '-1';
  DeepRefresh;
  fTreeEditSync.ReselectNode;
end;

procedure TfrmParserBuilderMain.actBuildFromFileExecute(Sender: TObject);
begin
  BuildFromFile;
end;

procedure TfrmParserBuilderMain.BuildFromFile;
var
  CGen: TCocoGen3;
begin
  OpenDialog1.FileName := '*.atg';
  if (OpenDialog1.Execute) then
  begin
    CGen := TCocoGen3.Create;
    fpbSHRichEdit.Enabled := False;
    try
      CGen.GrammarName := OpenDialog1.FileName;
      CGen.FramesDirectory := ExtractFilePath(Application.ExeName) + '\Frames';
      CGen.ErrorFormat := edErrorFormat.Text;
      CGen.Execute;
      memoReport.Lines.BeginUpdate;
      memoReport.Lines.Text := cGen.OutputStream.DataString;
      memoReport.Lines.EndUpdate;
      reParserOutput.Lines.BeginUpdate;
      reParserOutput.Text := cGen.ParserStream.DataString;
      reParserOutput.Lines.EndUpdate;
      reScannerOutput.Lines.BeginUpdate;
      reScannerOutput.Text := cGen.ScannerStream.DataString;
      reScannerOutput.Lines.EndUpdate;
      reProjectOutput.Lines.BeginUpdate;
      reProjectOutput.Text := cGen.CompilerStream.DataString;
      reProjectOutput.Lines.EndUpdate;
      if (cGen.Succeeded) then
        UserMessage('ATG Syntax OK')
      else
        UserMessage('Error: ATG Syntax Bad');
    finally
      CGen.Free;
      pagectrlATGEditing.ActivePageIndex := 1;
      pagectrlOutputViews.BringToFront;
      pagectrlOutputViews.ActivePageIndex := 3;
      // reset so the screen updates
      fPrevEditName := '-1';
      seFontSize.Enabled := False;
      fpbSHRichEdit.Enabled := True;
      fpbSHRichEdit.TabStop := False;
      memoReport.SetFocus;
    end;
  end;
end;

procedure TfrmParserBuilderMain.actCompWrapperExecute(Sender: TObject);
begin
  CreateComponentWrapper;
end;

procedure TfrmParserBuilderMain.CreateComponentWrapper;
var
  S, FN: string;
begin
  S := shCompTemplate.Strings.Text;
  S := ReplaceAll(S, '-->Grammar', FActiveCompiler.CompilerName);
  FN := RemoveBackSlash(FActiveCompiler.TargetDirectory) + '\' +
    FActiveCompiler.CompilerName + 'Component.pas';

  SaveString(S, FN);
  UserMessage('Component saved as ' + FN);
end;

function TfrmParserBuilderMain.IsProdNodeDirty: boolean;
var 
  S, S1: string;
begin
  if (FActiveCompiler.Productions.Count <> fCOCOTreeBuilder.ProdCount) then
  begin
    Result := True;
  end
  else
  begin
    S := FActiveCompiler.GetProdNamesList;
    S1 := fCOCOTreeBuilder.GetProdNodeNamesList;
    Result := not SameText(S, S1);
  end;
end;

procedure TfrmParserBuilderMain.UpdateFramesPanel;
begin
  CorrectFramesAndPaths;
  fnCompFrame.Text := Trim(fActiveCompiler.COMPILERFRAME);
  fnParserFrame.Text := Trim(fActiveCompiler.ParserFrame);
  fnScannerFrame.Text := Trim(fActiveCompiler.ScannerFrame);
  if DirExists(FActiveCompiler.TargetDirectory) then
    diredOutputDirectory.Text := FActiveCompiler.TargetDirectory
  else
  begin
    diredOutputDirectory.Text := ExtractFilePath(Application.ExeName) + 'Output';
    FActiveCompiler.TargetDirectory := diredOutputDirectory.Text;
  end;

  if FileExists(FActiveCompiler.CurrentDelphiProject) then
    edEXENAME.Text := FActiveCompiler.CurrentDelphiProject
  else
  begin
    edExeName.Text := RemoveBackSlash(FActiveCompiler.TargetDirectory) + '\' +
      FActiveCompiler.CompilerName + 'TestHarness.dpr';
  end;
end;

procedure TfrmParserBuilderMain.actClearHistoryExecute(Sender: TObject);
begin
  ClearHistory;
end;

procedure TfrmParserBuilderMain.ClearHistory;
begin
  fFileSys.ClearHistory;
  fFileSys.DoBackup;
  pnlHistory.Hide;
  fHistoryShowing := False;
  fPrevEditName := '-1';
  tvATGLibrary.SetFocus;
  fTreeEditSync.SelectCompilerRootNode;
end;

procedure TfrmParserBuilderMain.actFindATGExecute(Sender: TObject);
begin
  FindNodeFromSelText;
end;

procedure TfrmParserBuilderMain.FindNodeFromSelText;
var
  S: string;
begin
  if (ActiveControl is TCustomEdit) then
    S := Trim(TCustomEdit(ActiveControl).SelText)
  else
    S := Trim(GetProdUnderCursor);
  if Pos(':', S) > 0 then s := strExtract(S, 1, ':');
  fTreeEditSync.SelectNodeNamed(S);
  pagectrlATGEditing.ActivePageIndex := 0;
  fpbSHRichEdit.SetFocus;
  fpbSHRichEdit.SelStart := 0;
end;

function TfrmParserBuilderMain.GetProdUnderCursor: string;
begin
  Result := Trim(fpbSHRichEdit.SelText);
end;

function TfrmParserBuilderMain.HelpRouter1Help(Command: word;
  Data: Integer; var CallHelp: boolean): boolean;
begin
  Result := False;
  if Data = 10001 then 
  begin
    HelpRouter1.HelpJump(HelpRouter1.Helpfile, 'ATG Editor');
  end;
end;

procedure TfrmParserBuilderMain.actViewLanguageSampleExecute(Sender: TObject);
begin
  ViewLanguageSample;
end;

procedure TfrmParserBuilderMain.LoadLanguageSample;
var 
  S: string;
begin
  OpenDialog1.FileName := RemoveBackSlash(FActiveCompiler.TargetDirectory) + '\sample.txt';
  OpenDialog1.FilterIndex := 3;
  if (OpenDialog1.Execute) then
  begin
    LoadString(S, OpenDialog1.FileName);
    FActiveCompiler.LanguageSample := S;
    ViewLanguageSample;
  end;
end;

procedure TfrmParserBuilderMain.ViewLanguageSample;
begin
  FActiveCompiler.ResetAllEditFlags;
  pagectrlATGEditing.ActivePageIndex := 0;
  pnlOptions.Visible := False;
  pnlFrames.Visible := False;
  lblUtilMemo.LabelCaption := 'Language Sample';
  memoLangSamp.Text := FActiveCompiler.LanguageSample;
  pnlLangSamp.Visible := True;
  pnlLangSamp.BringToFront;
  pnlHistory.Hide;
  fHistoryShowing := False;
  UserMessage('Showing Language Sample Editor');
  fTreeEditSync.LSNodeCaption := '';
  memoLangSamp.SetFocus;
end;

procedure TfrmParserBuilderMain.memoLangSampChange(Sender: TObject);
begin
  if (FActiveCompiler <> nil) then
    FActiveCompiler.LanguageSample := memoLangSamp.Text;
end;

procedure TfrmParserBuilderMain.actLoadLanguageSampleExecute(Sender: TObject);
begin
  LoadLanguageSample;
end;

procedure TfrmParserBuilderMain.actStringifyExecute(Sender: TObject);
begin
  Stringify;
end;

procedure TfrmParserBuilderMain.Stringify;
var 
  S: string;
begin
  S := fpbSHRichEdit.SelText;
  S := '"' + ReplaceAll(Trim(S), ' ', '" "') + '" ';
  fpbSHRichEdit.SelText := S;
end;

procedure TfrmParserBuilderMain.OnATGEditorModified(Sender: TObject;
  var Key: word; Shift: TShiftState);
var 
  S: string;
begin
  fTreeEditSync.EditCurrentNode;
  if (ssCtrl in Shift) and (Key = $39) then
  begin
    if (ssShift in Shift) then S := 'SetStart;'
    else if (ssAlt in Shift) then S := 'WriteStr( CopySourceToCurrent );'
    else
      S := '';
    fpbSHRichEdit.SelText := fpbSHRichEdit.SelText + ' (.  ' + S + '  .)';
    fpbSHRichEdit.SelLength := 0;
    fpbSHRichEdit.SelStart := fpbSHRichEdit.SelStart - 4;
  end;
end;

procedure TfrmParserBuilderMain.SetScraps(const Value: string);
begin
  FScraps := Value;
end;

procedure TfrmParserBuilderMain.AddToScraps;
begin
  EditCopy1.Execute;
  memoScraps.Lines.Insert(0, '//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-');
  memoScraps.Lines.Insert(0, Clipboard.AsText);
  memoScraps.Lines.SaveToFile(ChangeFileExt(Application.ExeName, '.scraps'));
end;

procedure TfrmParserBuilderMain.ViewScraps;
begin
  pagectrlATGEditing.ActivePageIndex := 1;
  pnlScraps.BringToFront;
  seFontSize.Enabled := False;
  memoScraps.SetFocus;
end;

procedure TfrmParserBuilderMain.actAddToScrapsExecute(Sender: TObject);
begin
  AddToScraps;
end;

procedure TfrmParserBuilderMain.actViewScrapsExecute(Sender: TObject);
begin
  ViewScraps;
end;

procedure TfrmParserBuilderMain.actBackExecute(Sender: TObject);
var 
  FNew, PrevSel: string;
begin
  // Navigate to previously selected node
  fNew := fTreeEditSync.LSNodeCaption;
  fPrevEditName := '-1';
  PrevSel := fBack;
  fTreeEditSync.SelectNodeNamed(fBack);
  if (PrevSel = 'Options') then
    EditOptions
  else if (PrevSel = 'Frames') then
    EditFrames
  else
    ShowATGEditor;
  fBack := fNew;
end;

procedure TfrmParserBuilderMain.actForwardExecute(Sender: TObject);
begin
  // Navigate to previously selected node
  fTreeEditSync.SelectNodeNamed(fForward);
end;

procedure TfrmParserBuilderMain.CustomizeActionBars1Execute(Sender: TObject);
begin
  CustomizeDlg1.Show;
end;

procedure TfrmParserBuilderMain.btnSetProjectDPRNameClick(Sender: TObject);
begin
  fActiveCompiler.TargetDirectory := diredOutputDirectory.LongName;
  fActiveCompiler.CurrentDelphiProject := '';
  EditFrames;
end;

procedure TfrmParserBuilderMain.JvDragDrop1Drop(Sender: TObject;
  Pos: TPoint; Value: TStringList);
var
  idx: integer;
  S : String;
begin
  // User has dragged one or more files onto the form
  // IF they are ATG files, then load them as if loaded
  // via File | Open
  for idx := 0 to Value.Count - 1 do
  begin
    if system.pos('.ATG', Uppercase(Value[idx])) > 0 then
    begin
      UserMessage('Opening dragged file ' + Value[idx]);
      SetFileSystemCompiler(nil);
      OpenFile(Value[idx]);
    end
    Else
    Begin
      // File will be treated like a language sample
      // for the active parser
      If FActiveCompiler <> NIL then
        Begin
          LoadString(S, Value[idx]);
          FActiveCompiler.LanguageSample := S;
          ViewLanguageSample;
          Exit;
        End;
    End;
  end;
  fTreeEditSync.SelectCompilerRootNode;
  EditSelectedTreeItem;
  HighlightEditorOnce;
end;

procedure TfrmParserBuilderMain.actHighlightChangesExecute(Sender: TObject);
begin
  btnHighlightChanges.Down := actHighlightChanges.Checked;
  DoHistoryTitleSelected;
end;

procedure TfrmParserBuilderMain.ParserBuilderCommands1Click(Sender: TObject);
begin
  HelpRouter1.HelpJump(HelpRouter1.Helpfile, 'PBCommands.htm');
end;

procedure TfrmParserBuilderMain.actSwitchActiveParserExecute(Sender: TObject);
begin
  SwitchActiveParser;
end;

{-----------------------------------------------------------------------------
  Procedure: TfrmParserBuilderMain.SwitchActiveParser
  Selects the next parser in the tree
-----------------------------------------------------------------------------}
procedure TfrmParserBuilderMain.SwitchActiveParser;
var
  idx: integer;
  S: string;
begin
  idx := FCompilerList.IndexOf(FActiveCompiler);
  if (idx>-1) then
  begin
    S := fTreeEditSync.LSNodeCaption;
    if idx < FCompilerList.Count - 1 then
      SetActiveCompiler(FCompilerlist[idx + 1])
    else
      SetActiveCompiler(FCompilerlist[0]);
    fTreeEditSync.SelectCompilerRootNode;
    fTreeEditSync.LSNodeCaption := S;
    fTreeEditSync.ReselectNode;
  end;
end;

procedure TfrmParserBuilderMain.KeyboardShortcuts1Click(Sender: TObject);
begin
  HelpRouter1.HelpJump(HelpRouter1.Helpfile, 'Shortcuts.htm');
end;

end.
