{-----------------------------------------------------------------------------
 Unit Name: pbCocoConstants
 Author:    taken from COCO/R for TP 1.51 by Prof Pat Terry
 Purpose: Constants to support pbCocoLib -
-----------------------------------------------------------------------------}
unit pbCocoConstants;

interface

const
  Set_size = 16;
  Set_Limit = 32;

  maxSetNr = 200; (* max. number of symbol sets *)
  maxNames = 400; (* max. number of declared token names *)

  (* (from COCO/R for TurboPascal 1.51) - The following are chosen to ensure that data segments remain within the
   64K limit imposed by Dos 16 bit systems.  Manipulate them at your peril
   if you need to handle large grammars! *)

  (* pc - later version may expose these parameters for editing through the GUI
          if the need arises *)

  maxSymbols = 1024; (* max number of symbols (terminals+nonterminals+pragmas) *)
  maxTerminals = 1024; (* max number of terminals *)
  maxNt = 512; (* max number of nonterminals *)
  maxNodes = 6000; (* max number of top-down graph nodes *)
  maxClasses = 1000; (* max number of character classes *)
  maxSemLen = 64000; (* max length of a semantic text *)
  normTrans = 0; (* DFA transition during normal scanning *)
  contextTrans = 1; (* DFA transition during scanning of right context *)
  maxList = 150; (* max array size in FindCircularProductions *)
  maxLiterals = 511; (* max number of literal terminals *)
  MaxNameLength = 39; (* max length of token name *)
  symSetSize = 400; (* max.number of symbol sets of the generated parser *)
  maxTerm = 5; (* sets of size < maxTerm are enumerated *)
  maxAlter = 5; (* more than maxAlter alternatives are handled with  a case statement *)
  (* kinds of generated error messages *)
  MaxSourceLineLength = 78;
  NodeSetSize = maxNodes div Set_size;

  ATGExt = '.atg';
  LSTExt = '.lst';

  (* token kinds *)
  classToken = 0; (* token Class *)
  litToken = 1; (* literal (e.g. keyword) not recognized by DFA *)
  classLitToken = 2; (* token class that can also match a literal *)
  tErr = 0; (* unmatched terminal symbol *)
  altErr = 1; (* unmatched alternatives *)
  syncErr = 2; (* error reported at synchronization point *)
  //  NodeSetSize = maxNodes div Set_size;

implementation

end.
