{-----------------------------------------------------------------------------
 Unit Name: NewATGWizard_Main
 Author:    pat connors
 Purpose: Main form of the New ATG Wizard.
          Uses Wizard Components from ALCOSoft - dynamically created.
-----------------------------------------------------------------------------}


unit NewATGWizard_Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, Wizard, StdCtrls, Buttons, Mask, ToolEdit,
  JvRadioGroup, JvGradientCaption, StrHlder, Placemnt;

type
  TfrmNewATGWizard = class(TForm)
    PageControl1: TPageControl;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    Label1: TLabel;
    edParserName: TEdit;
    Label2: TLabel;
    DirectoryEdit1: TDirectoryEdit;
    JvRadioGroup1: TJvRadioGroup;
    JvRadioGroup2: TJvRadioGroup;
    JvRadioGroup3: TJvRadioGroup;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    Label5: TLabel;
    Label6: TLabel;
    CheckBox2: TCheckBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Label7: TLabel;
    JvGradientCaption1: TJvGradientCaption;
    JvGradientCaption2: TJvGradientCaption;
    JvGradientCaption3: TJvGradientCaption;
    JvGradientCaption4: TJvGradientCaption;
    DelphiStrings: TStrHolder;
    CharStrings: TStrHolder;
    TokenStrings: TStrHolder;
    FormStorage1: TFormStorage;
    Tokens2: TStrHolder;
    CheckBox3: TCheckBox;
    procedure CheckBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
  private
    FATG: string;
    Wizard1: TWizard;
    procedure SetATG(const Value: string);
    procedure AfterPageChange(Sender: TObject; PageIndex: Integer);
  public
    { Public declarations }
    property ATG: string read FATG write SetATG;
  end;

var
  frmNewATGWizard: TfrmNewATGWizard;

implementation

{$R *.dfm}

procedure TfrmNewATGWizard.SetATG(const Value: string);
begin
  FATG := Value;
end;

procedure TfrmNewATGWizard.CheckBox1Click(Sender: TObject);
begin
  //  CheckBox1.Checked
  Edit1.Enabled := CheckBox1.Checked;
  Edit2.Enabled := CheckBox1.Checked;
  CheckBox2.Enabled := CheckBox1.Checked;
end;

procedure TfrmNewATGWizard.FormCreate(Sender: TObject);
begin
  Wizard1 := TWizard.Create(Self);
  with Wizard1 do
  begin
    Name := 'Wizard1';
    DefImages := False;
    Prior := BitBtn1;
    Next := BitBtn2;
    Finish := BitBtn3;
    PageCtrl := PageControl1;
    FirstIndex := 0;
    LastIndex := -1;
    AfterNext := AfterPageChange;
    Designer := False;
    Left := 24;
    Top := 184;
  end;
end;

procedure TfrmNewATGWizard.FormDestroy(Sender: TObject);
begin
  Wizard1.Free;
end;

procedure TfrmNewATGWizard.PageControl1Change(Sender: TObject);
begin
  if PageControl1.ActivePageIndex = 3 then
    BitBtn3.Default := True;
end;

procedure TfrmNewATGWizard.AfterPageChange(Sender: TObject;
  PageIndex: Integer);
begin
  case PageIndex of
    0: BitBtn2.Default := True;
    1..2: BitBtn2.Default := True;
    3: BitBtn3.Default := True;
  end; //Case
end;

end.
