// Generated by ParserBuilder @ 17/04/2002 5:09:34 PM

unit ProdCheck2Parser;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder - unless you run the Delphi Import command*)


interface

uses
  Windows, Messages, SysUtils, Classes, Dialogs, pbStrLib, ProdCheck2Scanner;


const
  maxT = 24;
  minErrDist = 2;  (* minimal distance (good tokens) between two errors *)
  setsize = 16;  (* sets are stored in 16 bits *)

type
  BITSET = set of 0..15;
  TSymbolSet = array [0..maxT div setsize] of BITSET;



type
  TProdCheck2Parser = class(TProdCheck2Scanner)
  private
    FSuccessful: boolean;
    {PBPRIVATE}
    fOutputStream: TStringStream;
    fCollectStart: Integer;
    fCollectLength: Integer;
    procedure Init;
    procedure Final;
    procedure WriteStr(S: string);
    procedure ReportError(nr, line, col, pos: Integer);

    {ENDPBPRIVATE}
    procedure PerformGet;
    procedure SynError(errNo: Integer);
    procedure SemError(errNo: Integer);
    function _In(var s: TSymbolSet; x: Integer): boolean;
    procedure Expect(n: Integer);
    procedure ExpectWeak(n, follow: Integer);
    function WeakSeparator(n, syFol, repFol: Integer): boolean;
    function GetSuccessful: boolean;
    procedure SetSourceString(const Value: string);
    procedure _CloseCurly;
    procedure _OpenCurly;
    procedure _Symbol;
    procedure _Factor;
    procedure _Term;
    procedure _Expression;
    procedure _SemText;
    procedure _Attribs;
    procedure _Ident;
    procedure _ProductionList;
    procedure _ProdCheck2;


  protected
    {PBPROTECTED}
     
    {ENDPBPROTECTED}
  public
    {PBPUBLIC}
    
    {ENDPBPUBLIC}
    constructor Create;
    destructor Destroy; override;
    procedure Parse;
    procedure LexString(var Lex: string);
    procedure LexName(var Lex: string);
    procedure LookAheadString(var Lex: string);
    procedure LookAheadName(var Lex: string);
  published
    property Successful: boolean read GetSuccessful;
    property SourceString: string write SetSourceString;
    {PBPUBLISHED}
    
    {ENDPBPUBLISHED}
  end;

implementation

var
  symSet: array [0..11] of TSymbolSet;
  errDist: integer;
  sym: integer;

{  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
   + For ParserBuilder's Delphi import function to work,        -
   + you must place your code in this Arbitrary Source section. -
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- }

  {PBARBITRARYSOURCE}


procedure TProdCheck2Parser.Init;
begin
  fOutputStream.Size := 0;
  fCollectStart := 0;
  fCollectLength := 0;
  lst.Size := 0;
end;



procedure TProdCheck2Parser.Final;
begin
  if Errors = 0 then
    lst.WriteString('No Errors');
  lst.WriteString(fOutputStream.DataString);
  fOutputStream.Size := 0;
end;

procedure TProdCheck2Parser.WriteStr(S: string);
begin
  fOutputStream.WriteBuffer(S[1], length(S));
end;

procedure TProdCheck2Parser.ReportError(nr, line, col, pos: Integer);
var
  S, S1: string;
  SL: TStringList;
begin
  case nr of
    {$I  ProdCheck2.err}
  end; // Case
  S := S + CRLF + 'Line ' + IntToStr(line) + CRLF + 'Column ' + IntToStr(col) + CRLF;
  SL := TStringList.Create;
  SL.Text := src.DataString;
  S1 := SL[Line - 1];
  SL.Free;
  Insert(' >*ERROR*> ', S1, Col - 1);
  Inc(fErrors);
  WriteStr(S + S1);
end;




{ENDPBARBITRARYSOURCE}

 { TProdCheck2Parser - Generated Methods below}
procedure TProdCheck2Parser.SemError(errNo: Integer);
begin
  if errDist >= minErrDist then
  begin
    Error(errNo, line, col, pos);
  end;
  errDist := 0;
end;

procedure TProdCheck2Parser.SynError(errNo: Integer);
begin
  if errDist >= minErrDist then
  begin
    Error(errNo, nextLine, nextCol, nextPos);
  end;
  errDist := 0;
end;

procedure TProdCheck2Parser.PerformGet;
begin
  repeat
    Get(sym);
    if sym <= maxT then
      INC(errDist)
    else
    begin     
    end;
  until sym <= maxT
  end;

function TProdCheck2Parser._In(var s: TSymbolSet; x: Integer): boolean;
begin
  _In := x mod setsize in s[x div setsize];
end;

function TProdCheck2Parser.GetSuccessful: boolean;
begin
  FSuccessful := errors = 0;
  Result := FSuccessful;
end;

procedure TProdCheck2Parser.Expect(n: Integer);
begin
  if Sym = n then PerformGet
  else
    SynError(n);
end;

procedure TProdCheck2Parser.ExpectWeak(n, follow: Integer);
begin
  if Sym = n then PerformGet
  else
  begin
    SynError(n);
    while not _In(symSet[follow], Sym) do PerformGet;
  end
end;

function TProdCheck2Parser.WeakSeparator(n, syFol, repFol: Integer): boolean;
var
  s: TSymbolSet;
  i: integer;
begin
  if sym = n then
  begin
    PerformGet;
    WeakSeparator := True;
    EXIT;
  end
  else if _In(symSet[repFol], sym) then
  begin
    WeakSeparator := False;
    exit
  end
  else
  begin
    i := 0;
    while i <= maxT div setsize do
    begin
      s[i] := symSet[0, i] + symSet[syFol, i] + symSet[repFol, i];
      INC(i)
    end;
    SynError(n);
    while not _In(s, sym) do PerformGet;
    WeakSeparator := _In(symSet[syFol], sym)
  end
end;

procedure TProdCheck2Parser.LexName(var Lex: string);
begin
  GetName(pos, len, Lex)
end;

procedure TProdCheck2Parser.LexString(var Lex: string);
begin
  GetString(pos, len, Lex)
end;

procedure TProdCheck2Parser.LookAheadName(var Lex: string);
begin
  GetName(nextPos, nextLen, Lex);
end;

procedure TProdCheck2Parser.LookAheadString(var Lex: string);
begin
  GetString(nextPos, nextLen, Lex)
end;

procedure TProdCheck2Parser.SetSourceString(const Value: string);
begin
  if (src <> nil) then
    src.Free;
  src := TStringStream.Create(Value);
end;

procedure TProdCheck2Parser._CloseCurly;
begin
  Expect(23);
end;

procedure TProdCheck2Parser._OpenCurly;
begin
  Expect(22);
end;

procedure TProdCheck2Parser._Symbol;
begin
  if (sym = 1) then 
  begin
    _Ident;
  end 
  else if (sym = 2) then 
  begin
    PerformGet;
  end 
  else 
  begin 
    SynError(25);
  end;
end;

procedure TProdCheck2Parser._Factor;
begin
  case sym of
    1, 2, 9: 
    begin
      if (sym = 9) then 
      begin
        PerformGet;
      end;
      _Symbol;
      if (sym = 16) then 
      begin
        _Attribs;
      end 
      else if _In(symSet[1], sym) then 
      begin
        {105}
      end 
      else 
      begin 
        SynError(26);
      end;
    end;
    10: 
    begin
      PerformGet;
      _Expression;
      Expect(11);
    end;
    12: 
    begin
      PerformGet;
      _Expression;
      Expect(13);
    end;
    22: 
    begin
      _OpenCurly;
      _Expression;
      _CloseCurly;
    end;
    20: 
    begin
      _SemText;
    end;
    14: 
    begin
      PerformGet;
    end;
    15: 
    begin
      PerformGet;
    end;
    else 
    begin 
      SynError(27);
    end;
  end;
end;

procedure TProdCheck2Parser._Term;
begin
  if _In(symSet[2], sym) then 
  begin
    _Factor;
    while _In(symSet[2], sym) do 
    begin
      _Factor;
    end;
  end 
  else if (sym = 7) or (sym = 8) or (sym = 11) or (sym = 13) or (sym = 23) then 
  begin
    {EmptyAlternative}
  end 
  else 
  begin 
    SynError(28);
  end;
end;

procedure TProdCheck2Parser._Expression;
begin
  _Term;
  while WeakSeparator(8, 1, 3) do 
  begin
    _Term;
  end;
end;

procedure TProdCheck2Parser._SemText;
begin
  Expect(20);
  while _In(symSet[4], sym) do 
  begin
    if _In(symSet[5], sym) then 
    begin
      PerformGet;
    end 
    else if (sym = 3) then 
    begin
      PerformGet;
      SemError(102)
    end 
    else 
    begin
      PerformGet;
      SemError(109)
    end;
  end;
  Expect(21);
end;

procedure TProdCheck2Parser._Attribs;
begin
  Expect(16);
  while _In(symSet[6], sym) do 
  begin
    if _In(symSet[7], sym) then 
    begin
      PerformGet;
    end 
    else 
    begin
      PerformGet;
      SemError(102)
    end;
  end;
  Expect(17);
  Expect(18);
  while _In(symSet[8], sym) do 
  begin
    if _In(symSet[9], sym) then 
    begin
      PerformGet;
    end 
    else 
    begin
      PerformGet;
      SemError(102)
    end;
  end;
  Expect(19);
end;

procedure TProdCheck2Parser._Ident;
begin
  Expect(1);
end;

procedure TProdCheck2Parser._ProductionList;
begin
  if (sym = 5) then 
  begin
    PerformGet;
  end;
  while (sym = 1) do 
  begin
    _Ident;
    { Production Name Checking }
    if (sym = 16) then 
    begin
      _Attribs;
      {Attribute Checking1}
    end 
    else if (sym = 6) or (sym = 20) then 
    begin
      {Attribute Checking2}
    end 
    else 
    begin 
      SynError(29);
    end;
    if (sym = 20) then 
    begin
      _SemText;
    end;
    ExpectWeak(6, 10);
    _Expression;
    {Expression Checking}
    ExpectWeak(7, 11);
  end;
  {End Production Checking}
end;

procedure TProdCheck2Parser._ProdCheck2;
begin
  Init;
  _ProductionList;
  Final;
end;



procedure TProdCheck2Parser.Parse;
begin
  if (src.DataString = '') then 
    lst.WriteString('Empty Source')
  else 
  begin    
    _Reset; 
    PerformGet;
    _ProdCheck2;
  end;
end;

destructor TProdCheck2Parser.Destroy;
begin
  {PBDESTROY}
  fOutputStream.Free;

  {ENDPBDESTROY}
  inherited;
end;

constructor TProdCheck2Parser.Create;
begin
  inherited;
  {PBCREATE}
  fOutputStream := TStringStream.Create('');
  Error := ReportError;

  {ENDPBCREATE}
  errDist := minErrDist;
  symSet[0, 0] := [15];
  symSet[0, 1] := [];
  symSet[1, 0] := [1, 2, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[1, 1] := [4, 6, 7];
  symSet[2, 0] := [1, 2, 9, 10, 12, 14, 15];
  symSet[2, 1] := [4, 6];
  symSet[3, 0] := [7, 11, 13];
  symSet[3, 1] := [7];
  symSet[4, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[4, 1] := [0, 1, 2, 3, 4, 6, 7, 8];
  symSet[5, 0] := [0, 1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[5, 1] := [0, 1, 2, 3, 6, 7, 8];
  symSet[6, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[6, 1] := [0, 2, 3, 4, 5, 6, 7, 8];
  symSet[7, 0] := [0, 1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[7, 1] := [0, 2, 3, 4, 5, 6, 7, 8];
  symSet[8, 0] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[8, 1] := [0, 1, 2, 4, 5, 6, 7, 8];
  symSet[9, 0] := [0, 1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
  symSet[9, 1] := [0, 1, 2, 4, 5, 6, 7, 8];
  symSet[10, 0] := [1, 2, 7, 8, 9, 10, 12, 14, 15];
  symSet[10, 1] := [4, 6];
  symSet[11, 0] := [1, 15];
  symSet[11, 1] := [];
end;


end.
