// Generated by ParserBuilder @ 12/04/2002 8:21:15 PM

unit SemActionFormatterParser;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder *)


interface

uses
  Windows, Messages, SysUtils, Classes, Dialogs, pbStrLib, SemActionFormatterScanner;


const
  maxT = 11;
  minErrDist = 2;  (* minimal distance (good tokens) between two errors *)
  setsize = 16;  (* sets are stored in 16 bits *)

type
  BITSET = set of 0..15;
  TSymbolSet = array [0..maxT div setsize] of BITSET;



type
  TSemActionFormatterParser = class(TSemActionFormatterScanner)
  private
    FSuccessful: boolean;
    fOutputStream: TStringStream;
    fCollectStart: Integer;
    fCollectLength: Integer;
    fEOLChar: string;
    fIndent: Integer;
    fMinIndent: Integer;
    fStartIndent: Integer;
    fRegIndent: Integer;
    procedure Init;
    procedure Final;
    function CalcLength: Integer;
    procedure SetStart;
    function CopySourceToCurrent: string;
    procedure WriteStr(S: string);
    //    function GetLexString: string;
    procedure ReportError(nr, line, col, pos: Integer);

    procedure PerformGet;
    procedure SynError(errNo: Integer);
    //    procedure SemError(errNo: Integer);
    function _In(var s: TSymbolSet; x: Integer): boolean;
    procedure Expect(n: Integer);
    //    procedure ExpectWeak(n, follow: Integer);
    function WeakSeparator(n, syFol, repFol: Integer): boolean;
    function GetSuccessful: boolean;
    procedure SetSourceString(const Value: string);
    procedure _SemText;
    procedure _SemActionFormatter;


  protected
    
  public
    
    constructor Create;
    destructor Destroy; override;
    procedure Parse;
    procedure LexString(var Lex: string);
    procedure LexName(var Lex: string);
    procedure LookAheadString(var Lex: string);
    procedure LookAheadName(var Lex: string);
  published
    property Successful: boolean read GetSuccessful;
    property SourceString: string write SetSourceString;
    property MinIndent: Integer read fMinIndent write fMinIndent;
    property StartIndent: Integer read fStartIndent write fStartIndent;

  end;

implementation

var
  symSet: array [0..0] of TSymbolSet;
  errDist: integer;
  sym: integer;

procedure TSemActionFormatterParser.SetStart;
begin
  fCollectStart := nextPos + 1;
end;

procedure TSemActionFormatterParser.Init;
begin
  fOutputStream.Size := 0;
  fCollectStart := 0;
  fCollectLength := 0;
  lst.Size := 0;
  fIndent := 0;
  fRegIndent := 0;
end;

function TSemActionFormatterParser.CopySourceToCurrent: string;
begin
  CalcLength;
  Result := Copy(src.DataString, FCollectStart, fCollectLength);
end;

function TSemActionFormatterParser.CalcLength: Integer;
begin
  Result := nextPos - fCollectStart + 1;
  fCollectLength := Result;
end;

procedure TSemActionFormatterParser.Final;
begin
  if Errors > 0 then
    lst.WriteString('Errors----------------------' + #13#10);
  lst.WriteString(fOutputStream.DataString);
  fOutputStream.Size := 0;
end;

procedure TSemActionFormatterParser.WriteStr(S: string);
begin
  fOutputStream.WriteBuffer(S[1], length(S));
end;

//function TSemActionFormatterParser.GetLexString: string;
//begin
//  LexString(Result);
//end;

procedure TSemActionFormatterParser.ReportError(nr, line, col, pos: Integer);
var
  S, S1: string;
  SL: TStringList;
begin
  case nr of
    {$I  SemActionFormatter.err}
  end; // Case
  S := S + CRLF + 'Line ' + IntToStr(line) + CRLF + 'Column ' + IntToStr(col) + CRLF;
  SL := TStringList.Create;
  SL.Text := src.DataString;
  S1 := SL[Line - 1];
  SL.Free;
  Insert(' >*ERROR*> ', S1, Col - 1);
  Inc(fErrors);
  WriteStr(S + S1);
end;




 { TSemActionFormatterParser - Generated Methods }
//procedure TSemActionFormatterParser.SemError(errNo: Integer);
//begin
//  if errDist >= minErrDist then
//  begin
//    Error(errNo, line, col, pos);
//  end;
//  errDist := 0;
//end;

procedure TSemActionFormatterParser.SynError(errNo: Integer);
begin
  if errDist >= minErrDist then
  begin
    Error(errNo, nextLine, nextCol, nextPos);
  end;
  errDist := 0;
end;

procedure TSemActionFormatterParser.PerformGet;
begin
  repeat
    Get(sym);
    if sym <= maxT then
      INC(errDist)
    else
    begin        
    end;
  until sym <= maxT
  end;

function TSemActionFormatterParser._In(var s: TSymbolSet; x: Integer): boolean;
begin
  _In := x mod setsize in s[x div setsize];
end;

function TSemActionFormatterParser.GetSuccessful: boolean;
begin
  FSuccessful := errors = 0;
  Result := FSuccessful;
end;

procedure TSemActionFormatterParser.Expect(n: Integer);
begin
  if Sym = n then PerformGet
  else
    SynError(n);
end;

//procedure TSemActionFormatterParser.ExpectWeak(n, follow: Integer);
//begin
//  if Sym = n then PerformGet
//  else
//  begin
//    SynError(n);
//    while not _In(symSet[follow], Sym) do PerformGet;
//  end
//end;

function TSemActionFormatterParser.WeakSeparator(n, syFol, repFol: Integer): boolean;
var
  s: TSymbolSet;
  i: integer;
begin
  if sym = n then
  begin
    PerformGet;
    WeakSeparator := True;
    EXIT;
  end
  else if _In(symSet[repFol], sym) then
  begin
    WeakSeparator := False;
    exit
  end
  else
  begin
    i := 0;
    while i <= maxT div setsize do
    begin
      s[i] := symSet[0, i] + symSet[syFol, i] + symSet[repFol, i];
      INC(i)
    end;
    SynError(n);
    while not _In(s, sym) do PerformGet;
    WeakSeparator := _In(symSet[syFol], sym)
  end
end;

procedure TSemActionFormatterParser.LexName(var Lex: string);
begin
  GetName(pos, len, Lex)
end;

procedure TSemActionFormatterParser.LexString(var Lex: string);
begin
  GetString(pos, len, Lex)
end;

procedure TSemActionFormatterParser.LookAheadName(var Lex: string);
begin
  GetName(nextPos, nextLen, Lex);
end;

procedure TSemActionFormatterParser.LookAheadString(var Lex: string);
begin
  GetString(nextPos, nextLen, Lex)
end;

procedure TSemActionFormatterParser.SetSourceString(const Value: string);
begin
  if (src <> nil) then
    src.Free;
  src := TStringStream.Create(Value);
end;

procedure TSemActionFormatterParser._SemText;
begin
  fEOLChar := '';;
  Expect(5);
  WriteStr(StringOfChar(' ', fMinIndent - fStartIndent) + '(. ');
  while (sym < 16) (* prevent range error *) and
    (sym in [1, 2, 4, 6, 7, 8, 9]) do 
  begin
    case sym of
      1: 
      begin
        SetStart;
        PerformGet;
        while (sym = 1) do 
        begin
          PerformGet;
        end;
        WriteStr(fEOLChar + Trim(CopySourceToCurrent) + ' ');
        FRegIndent := 4;
        fEOLChar := '';;
      end;
      2: 
      begin
        SetStart;
        PerformGet;
        WriteStr(fEOLChar + CopySourceToCurrent);
        FRegIndent := 0;
        fEOLChar := '';;
      end;
      6: 
      begin
        PerformGet;
        if (sym = 6) then 
        begin
          PerformGet;
        end;
        WriteStr(';');
        fEOLChar := #13#10 + StringOfChar(' ', fMinIndent + fIndent + FRegIndent);
        FRegIndent := 3;;
      end;
      7: 
      begin
        SetStart;
        PerformGet;
        WriteStr(fEOLChar + 'begin');
        fEOLChar := #13#10 + StringOfChar(' ', fMinIndent + fIndent + FRegIndent);
        inc(fIndent, 2);
        FRegIndent := 3;;
      end;
      8: 
      begin
        SetStart;
        PerformGet;
        WriteStr(fEOLChar + 'else');
        fEOLChar := #13#10 + StringOfChar(' ', fMinIndent + fIndent + FRegIndent);
        FRegIndent := 3;;
      end;
      9: 
      begin
        SetStart;
        PerformGet;
        Dec(fIndent, 2);
        WriteStr(fEOLChar + CopySourceToCurrent);
        fEOLChar := #13#10 + StringOfChar(' ', fMinIndent + fIndent + FRegIndent);
        FRegIndent := 3;;
      end;
      4: 
      begin
        PerformGet;
        if fEOLChar = '' then
          fEOLChar := #13#10 + StringOfChar(' ', fMinIndent + fIndent + FRegIndent);
        FRegIndent := 3;;
      end;
    end;
  end;
  Expect(10);
  WriteStr(' .)');
  fEOLChar := #13#10;;
end;

procedure TSemActionFormatterParser._SemActionFormatter;
begin
  Init;;
  _SemText;
  Final;;
end;



procedure TSemActionFormatterParser.Parse;
begin
  _Reset; 
  PerformGet;
  _SemActionFormatter;
end;

destructor TSemActionFormatterParser.Destroy;
begin
  fOutputStream.Free;

  inherited;
end;

constructor TSemActionFormatterParser.Create;
begin
  inherited;
  fOutputStream := TStringStream.Create('');
  Error := ReportError;
  fMinIndent := 35;

  errDist := minErrDist;
  symSet[0, 0] := [];
end;


end.
